module     dgaad_d155h0l1
   ! file: /.th/pcl340/scratch/gosam/greiner/dg_aad/helicity0d155h0l1.f90
   ! generator: buildfortran.py
   use dgaad_config, only: ki
   use dgaad_util, only: cond
   implicit none
   private
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ function brack_1:
   pure function brack_1(Q,mu2) result(brack)
      use dgaad_model
      use dgaad_kinematics
      use dgaad_color
      use dgaad_abbrevd155h0
      implicit none
      complex(ki), dimension(4), intent(in) :: Q
      complex(ki), intent(in) :: mu2
      complex(ki) :: brack
      complex(ki) :: acc155(84)
      complex(ki) :: Qspvae3k1
      complex(ki) :: Qspe2
      complex(ki) :: Qspvae2k1
      complex(ki) :: Qspe3
      complex(ki) :: Qspvak2k1
      complex(ki) :: Qspe4
      complex(ki) :: Qspk5
      complex(ki) :: Qspvak5e4
      complex(ki) :: Qspvae4k1
      complex(ki) :: Qspvak5k1
      complex(ki) :: QspQ
      complex(ki) :: Qspvak5e3
      complex(ki) :: Qspk2
      complex(ki) :: Qspk1
      complex(ki) :: Qspvak3k1
      complex(ki) :: Qspvak5k2
      complex(ki) :: Qspvak5k3
      complex(ki) :: Qspk3
      Qspvae3k1 = dotproduct(Q,spvae3k1)
      Qspe2 = dotproduct(Q,e2)
      Qspvae2k1 = dotproduct(Q,spvae2k1)
      Qspe3 = dotproduct(Q,e3)
      Qspvak2k1 = dotproduct(Q,spvak2k1)
      Qspe4 = dotproduct(Q,e4)
      Qspk5 = dotproduct(Q,k5)
      Qspvak5e4 = dotproduct(Q,spvak5e4)
      Qspvae4k1 = dotproduct(Q,spvae4k1)
      Qspvak5k1 = dotproduct(Q,spvak5k1)
      QspQ = dotproduct(Q,Q)
      Qspvak5e3 = dotproduct(Q,spvak5e3)
      Qspk2 = dotproduct(Q,k2)
      Qspk1 = dotproduct(Q,k1)
      Qspvak3k1 = dotproduct(Q,spvak3k1)
      Qspvak5k2 = dotproduct(Q,spvak5k2)
      Qspvak5k3 = dotproduct(Q,spvak5k3)
      Qspk3 = dotproduct(Q,k3)
      acc155(1)=abb155(2)
      acc155(2)=abb155(3)
      acc155(3)=abb155(4)
      acc155(4)=abb155(5)
      acc155(5)=abb155(6)
      acc155(6)=abb155(7)
      acc155(7)=abb155(8)
      acc155(8)=abb155(9)
      acc155(9)=abb155(10)
      acc155(10)=abb155(11)
      acc155(11)=abb155(12)
      acc155(12)=abb155(13)
      acc155(13)=abb155(14)
      acc155(14)=abb155(15)
      acc155(15)=abb155(16)
      acc155(16)=abb155(17)
      acc155(17)=abb155(18)
      acc155(18)=abb155(19)
      acc155(19)=abb155(20)
      acc155(20)=abb155(21)
      acc155(21)=abb155(22)
      acc155(22)=abb155(23)
      acc155(23)=abb155(24)
      acc155(24)=abb155(25)
      acc155(25)=abb155(26)
      acc155(26)=abb155(27)
      acc155(27)=abb155(28)
      acc155(28)=abb155(29)
      acc155(29)=abb155(30)
      acc155(30)=abb155(31)
      acc155(31)=abb155(32)
      acc155(32)=abb155(33)
      acc155(33)=abb155(34)
      acc155(34)=abb155(35)
      acc155(35)=abb155(36)
      acc155(36)=abb155(37)
      acc155(37)=abb155(38)
      acc155(38)=abb155(39)
      acc155(39)=abb155(40)
      acc155(40)=abb155(41)
      acc155(41)=abb155(42)
      acc155(42)=abb155(43)
      acc155(43)=abb155(44)
      acc155(44)=abb155(45)
      acc155(45)=abb155(46)
      acc155(46)=abb155(47)
      acc155(47)=abb155(48)
      acc155(48)=abb155(49)
      acc155(49)=abb155(50)
      acc155(50)=abb155(51)
      acc155(51)=abb155(53)
      acc155(52)=abb155(54)
      acc155(53)=abb155(55)
      acc155(54)=abb155(57)
      acc155(55)=abb155(58)
      acc155(56)=abb155(60)
      acc155(57)=abb155(61)
      acc155(58)=abb155(62)
      acc155(59)=abb155(65)
      acc155(60)=abb155(66)
      acc155(61)=abb155(68)
      acc155(62)=abb155(69)
      acc155(63)=abb155(70)
      acc155(64)=abb155(72)
      acc155(65)=abb155(73)
      acc155(66)=abb155(74)
      acc155(67)=abb155(75)
      acc155(68)=Qspvae3k1*Qspe2
      acc155(69)=acc155(15)*acc155(68)
      acc155(70)=acc155(19)*Qspvae3k1
      acc155(71)=acc155(20)*Qspvae2k1
      acc155(72)=acc155(25)*Qspe3
      acc155(73)=acc155(30)*Qspvak2k1
      acc155(74)=Qspe3*Qspe4
      acc155(75)=acc155(31)*acc155(74)
      acc155(76)=acc155(34)*Qspk5
      acc155(77)=acc155(43)*Qspvak5e4
      acc155(78)=Qspvak5e4*Qspe2
      acc155(79)=acc155(45)*acc155(78)
      acc155(80)=Qspvae4k1*Qspe2
      acc155(81)=acc155(52)*acc155(80)
      acc155(82)=acc155(55)*Qspvak5k1
      acc155(69)=acc155(82)+acc155(81)+acc155(79)+acc155(77)+acc155(76)+acc155(&
      &75)+acc155(73)+acc155(72)+acc155(23)+acc155(71)+acc155(70)+acc155(69)
      acc155(69)=QspQ*acc155(69)
      acc155(70)=acc155(56)*Qspe4
      acc155(70)=acc155(70)+acc155(54)
      acc155(70)=Qspvae3k1*acc155(70)
      acc155(71)=acc155(13)*Qspvak5k1
      acc155(72)=acc155(17)*Qspvak5e3*Qspe4
      acc155(73)=acc155(18)*Qspk5
      acc155(75)=acc155(44)*Qspvak5e4
      acc155(76)=acc155(62)*Qspvae2k1
      acc155(77)=Qspvae2k1*Qspe4
      acc155(79)=acc155(64)*acc155(77)
      acc155(70)=acc155(79)+acc155(76)+acc155(75)+acc155(73)+acc155(72)+acc155(&
      &71)+acc155(70)
      acc155(70)=Qspk2*acc155(70)
      acc155(71)=acc155(2)*Qspe4
      acc155(71)=acc155(8)+acc155(71)
      acc155(71)=Qspvak5k1*acc155(71)
      acc155(72)=-Qspk1-Qspk5
      acc155(72)=acc155(14)*acc155(72)
      acc155(73)=acc155(9)*Qspvak3k1
      acc155(75)=acc155(10)*Qspvak2k1
      acc155(76)=acc155(39)*Qspvak5e4
      acc155(79)=acc155(50)*Qspvae4k1
      acc155(71)=acc155(79)+acc155(76)+acc155(75)+acc155(73)+acc155(72)+acc155(&
      &71)
      acc155(71)=acc155(71)*Qspe3
      acc155(72)=acc155(24)*Qspvak3k1
      acc155(71)=acc155(72)+acc155(71)
      acc155(71)=Qspe2*acc155(71)
      acc155(72)=acc155(35)*Qspvak2k1
      acc155(73)=acc155(41)*Qspvak5k2
      acc155(75)=acc155(46)*Qspvak5e3
      acc155(76)=acc155(49)*Qspvae3k1
      acc155(79)=acc155(53)*Qspvak3k1
      acc155(81)=acc155(67)*Qspvak5k3
      acc155(72)=acc155(81)+acc155(79)+acc155(76)+acc155(75)+acc155(73)+acc155(&
      &72)
      acc155(72)=acc155(72)*Qspe2
      acc155(73)=acc155(5)*Qspvak5k2
      acc155(75)=acc155(66)*Qspvak5k3
      acc155(72)=acc155(75)+acc155(73)+acc155(72)
      acc155(72)=Qspe4*acc155(72)
      acc155(73)=acc155(4)*Qspvak2k1
      acc155(75)=acc155(16)*acc155(68)
      acc155(76)=acc155(37)*QspQ
      acc155(79)=-acc155(42)*acc155(78)
      acc155(80)=-acc155(51)*acc155(80)
      acc155(73)=acc155(80)+acc155(79)+acc155(76)+acc155(75)+acc155(73)
      acc155(75)=Qspk3-Qspk2
      acc155(73)=acc155(75)*acc155(73)
      acc155(75)=acc155(3)*Qspe2
      acc155(76)=acc155(22)*Qspe4
      acc155(79)=acc155(28)*Qspe3
      acc155(80)=acc155(29)*acc155(74)
      acc155(75)=acc155(58)+acc155(80)+acc155(79)+acc155(76)+acc155(75)
      acc155(75)=Qspvak2k1*acc155(75)
      acc155(76)=acc155(47)*Qspe3
      acc155(79)=acc155(61)*acc155(74)
      acc155(80)=acc155(63)*Qspk3
      acc155(81)=QspQ*Qspe4
      acc155(82)=acc155(65)*acc155(81)
      acc155(76)=acc155(82)+acc155(80)+acc155(79)+acc155(59)+acc155(76)
      acc155(76)=Qspvae2k1*acc155(76)
      acc155(79)=acc155(38)*Qspe3
      acc155(80)=acc155(40)*Qspk3
      acc155(79)=acc155(80)+acc155(79)
      acc155(79)=Qspvak5e4*acc155(79)
      acc155(80)=acc155(6)*Qspe2
      acc155(82)=acc155(32)*Qspe3
      acc155(80)=acc155(57)+acc155(82)+acc155(80)
      acc155(80)=Qspvak5k1*acc155(80)
      acc155(82)=acc155(11)*Qspe3
      acc155(83)=acc155(12)*Qspe2
      acc155(82)=acc155(83)+acc155(82)+acc155(7)
      acc155(82)=Qspk5*acc155(82)
      acc155(83)=acc155(33)*Qspvak5e3
      acc155(84)=acc155(36)*Qspvae3k1
      acc155(83)=acc155(84)+acc155(83)+acc155(27)
      acc155(81)=acc155(81)*acc155(83)
      acc155(74)=acc155(1)*Qspvak5k2*acc155(74)
      acc155(78)=acc155(21)*acc155(78)
      acc155(83)=acc155(26)*QspQ**2
      acc155(68)=acc155(48)*acc155(68)
      acc155(77)=acc155(60)*acc155(77)
      brack=acc155(68)+acc155(69)+acc155(70)+acc155(71)+acc155(72)+acc155(73)+a&
      &cc155(74)+acc155(75)+acc155(76)+acc155(77)+acc155(78)+acc155(79)+acc155(&
      &80)+acc155(81)+acc155(82)+acc155(83)
   end  function brack_1
!---#] function brack_1:
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use dgaad_groups, only: &
!           & sign => diagram155_sign, shift => diagram155_shift
      use dgaad_globalsl1, only: epspow
      use dgaad_kinematics
      use dgaad_abbrevd155h0
      implicit none
      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d155
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(0:3) :: qshift
      qshift = k2
      Q(1)  =cmplx(real(+Q_ext(4)  -qshift(0),  ki_sam),aimag(+Q_ext(4)),  ki)
      Q(2:4)=cmplx(real(+Q_ext(1:3)-qshift(1:3),ki_sam),aimag(+Q_ext(1:3)),ki)
      mu2    = cmplx(real(mu2_ext, ki), aimag(mu2_ext), ki)
      d155 = 0.0_ki
      d155 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d155, ki), aimag(d155), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use dgaad_globalsl1, only: epspow
      use dgaad_kinematics
      use dgaad_abbrevd155h0
      implicit none
      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d155
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(4) :: qshift
      qshift = k2
      Q(:)  =cmplx(real(+Q_ext(:)  -qshift(:),  ki_gol), 0.0_ki_gol, ki)
      mu2  = cmplx(real(mu2_ext, ki), 0.0_ki, ki)
      d155 = 0.0_ki
      d155 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d155, ki), aimag(d155), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module dgaad_d155h0l1
