module     dgaad_d158h8l1
   ! file: /.th/pcl340/scratch/gosam/greiner/dg_aad/helicity8d158h8l1.f90
   ! generator: buildfortran.py
   use dgaad_config, only: ki
   use dgaad_util, only: cond
   implicit none
   private
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ function brack_1:
   pure function brack_1(Q,mu2) result(brack)
      use dgaad_model
      use dgaad_kinematics
      use dgaad_color
      use dgaad_abbrevd158h8
      implicit none
      complex(ki), dimension(4), intent(in) :: Q
      complex(ki), intent(in) :: mu2
      complex(ki) :: brack
      complex(ki) :: acc158(82)
      complex(ki) :: Qspvak1e4
      complex(ki) :: Qspe3
      complex(ki) :: Qspvak1e3
      complex(ki) :: Qspe4
      complex(ki) :: Qspe2
      complex(ki) :: Qspk5
      complex(ki) :: Qspvak1k3
      complex(ki) :: Qspvae2k5
      complex(ki) :: Qspvak1k5
      complex(ki) :: Qspvak1e2
      complex(ki) :: QspQ
      complex(ki) :: Qspvak4k5
      complex(ki) :: Qspvae4k5
      complex(ki) :: Qspvak3k5
      complex(ki) :: Qspvak1k4
      complex(ki) :: Qspk1
      complex(ki) :: Qspk3
      complex(ki) :: Qspk4
      Qspvak1e4 = dotproduct(Q,spvak1e4)
      Qspe3 = dotproduct(Q,e3)
      Qspvak1e3 = dotproduct(Q,spvak1e3)
      Qspe4 = dotproduct(Q,e4)
      Qspe2 = dotproduct(Q,e2)
      Qspk5 = dotproduct(Q,k5)
      Qspvak1k3 = dotproduct(Q,spvak1k3)
      Qspvae2k5 = dotproduct(Q,spvae2k5)
      Qspvak1k5 = dotproduct(Q,spvak1k5)
      Qspvak1e2 = dotproduct(Q,spvak1e2)
      QspQ = dotproduct(Q,Q)
      Qspvak4k5 = dotproduct(Q,spvak4k5)
      Qspvae4k5 = dotproduct(Q,spvae4k5)
      Qspvak3k5 = dotproduct(Q,spvak3k5)
      Qspvak1k4 = dotproduct(Q,spvak1k4)
      Qspk1 = dotproduct(Q,k1)
      Qspk3 = dotproduct(Q,k3)
      Qspk4 = dotproduct(Q,k4)
      acc158(1)=abb158(2)
      acc158(2)=abb158(3)
      acc158(3)=abb158(4)
      acc158(4)=abb158(5)
      acc158(5)=abb158(6)
      acc158(6)=abb158(7)
      acc158(7)=abb158(8)
      acc158(8)=abb158(9)
      acc158(9)=abb158(10)
      acc158(10)=abb158(11)
      acc158(11)=abb158(12)
      acc158(12)=abb158(13)
      acc158(13)=abb158(14)
      acc158(14)=abb158(15)
      acc158(15)=abb158(16)
      acc158(16)=abb158(17)
      acc158(17)=abb158(18)
      acc158(18)=abb158(19)
      acc158(19)=abb158(20)
      acc158(20)=abb158(21)
      acc158(21)=abb158(22)
      acc158(22)=abb158(23)
      acc158(23)=abb158(24)
      acc158(24)=abb158(25)
      acc158(25)=abb158(26)
      acc158(26)=abb158(27)
      acc158(27)=abb158(28)
      acc158(28)=abb158(29)
      acc158(29)=abb158(30)
      acc158(30)=abb158(31)
      acc158(31)=abb158(32)
      acc158(32)=abb158(33)
      acc158(33)=abb158(34)
      acc158(34)=abb158(35)
      acc158(35)=abb158(36)
      acc158(36)=abb158(37)
      acc158(37)=abb158(38)
      acc158(38)=abb158(39)
      acc158(39)=abb158(40)
      acc158(40)=abb158(41)
      acc158(41)=abb158(42)
      acc158(42)=abb158(43)
      acc158(43)=abb158(44)
      acc158(44)=abb158(45)
      acc158(45)=abb158(46)
      acc158(46)=abb158(47)
      acc158(47)=abb158(48)
      acc158(48)=abb158(49)
      acc158(49)=abb158(50)
      acc158(50)=abb158(51)
      acc158(51)=abb158(52)
      acc158(52)=abb158(53)
      acc158(53)=abb158(54)
      acc158(54)=abb158(55)
      acc158(55)=abb158(57)
      acc158(56)=abb158(58)
      acc158(57)=abb158(60)
      acc158(58)=abb158(64)
      acc158(59)=abb158(65)
      acc158(60)=abb158(66)
      acc158(61)=abb158(68)
      acc158(62)=abb158(69)
      acc158(63)=abb158(72)
      acc158(64)=abb158(73)
      acc158(65)=abb158(74)
      acc158(66)=abb158(75)
      acc158(67)=Qspvak1e4*Qspe3
      acc158(68)=acc158(21)*acc158(67)
      acc158(69)=acc158(24)*Qspvak1e3
      acc158(70)=acc158(26)*Qspe4
      acc158(71)=Qspe4*Qspe2
      acc158(72)=acc158(28)*acc158(71)
      acc158(73)=acc158(30)*Qspk5
      acc158(74)=acc158(34)*Qspvak1k3
      acc158(75)=acc158(43)*Qspvae2k5
      acc158(76)=acc158(44)*Qspvak1k5
      acc158(77)=Qspvae2k5*Qspe3
      acc158(78)=acc158(45)*acc158(77)
      acc158(79)=acc158(46)*Qspvak1e4
      acc158(80)=Qspvak1e2*Qspe3
      acc158(81)=acc158(65)*acc158(80)
      acc158(68)=acc158(81)+acc158(79)+acc158(78)+acc158(76)+acc158(75)+acc158(&
      &74)+acc158(73)+acc158(72)+acc158(70)+acc158(69)+acc158(68)+acc158(13)
      acc158(68)=QspQ*acc158(68)
      acc158(69)=acc158(5)*Qspvak4k5
      acc158(70)=acc158(35)*Qspvae4k5
      acc158(72)=acc158(41)*Qspvak3k5
      acc158(73)=acc158(47)*Qspvak1k3
      acc158(74)=acc158(51)*Qspvak1k4
      acc158(75)=acc158(52)*Qspvak1e4
      acc158(69)=acc158(75)+acc158(74)+acc158(73)+acc158(72)+acc158(70)+acc158(&
      &69)
      acc158(69)=acc158(69)*Qspe2
      acc158(70)=-acc158(1)*Qspe2
      acc158(70)=acc158(16)+acc158(70)
      acc158(70)=Qspvak1k5*acc158(70)
      acc158(72)=-Qspk1-Qspk5
      acc158(72)=acc158(18)*acc158(72)
      acc158(73)=acc158(10)*Qspvak1k4
      acc158(74)=acc158(11)*Qspvak1k3
      acc158(75)=acc158(39)*Qspvae2k5
      acc158(76)=acc158(50)*Qspvak1e2
      acc158(70)=acc158(76)+acc158(75)+acc158(74)+acc158(73)+acc158(72)+acc158(&
      &70)
      acc158(70)=acc158(70)*Qspe4
      acc158(72)=acc158(25)*Qspvak1k4
      acc158(69)=acc158(72)+acc158(70)+acc158(69)
      acc158(69)=Qspe3*acc158(69)
      acc158(70)=acc158(57)*Qspe2
      acc158(70)=acc158(70)+acc158(56)
      acc158(70)=Qspvak1e4*acc158(70)
      acc158(72)=acc158(3)*Qspvae2k5
      acc158(73)=-acc158(20)*Qspvae4k5*Qspe2
      acc158(74)=acc158(22)*Qspk5
      acc158(75)=acc158(55)*Qspvak1k5
      acc158(76)=acc158(62)*Qspvak1e3
      acc158(78)=Qspvak1e3*Qspe2
      acc158(79)=acc158(63)*acc158(78)
      acc158(70)=acc158(79)+acc158(76)+acc158(75)+acc158(74)+acc158(73)+acc158(&
      &72)+acc158(70)
      acc158(70)=Qspk3*acc158(70)
      acc158(72)=acc158(9)*acc158(80)
      acc158(73)=-acc158(33)*QspQ
      acc158(74)=-acc158(40)*Qspvak1k3
      acc158(75)=acc158(42)*acc158(77)
      acc158(76)=-acc158(53)*acc158(67)
      acc158(72)=acc158(76)+acc158(75)+acc158(74)+acc158(73)+acc158(72)
      acc158(73)=Qspk4+Qspk3
      acc158(72)=acc158(73)*acc158(72)
      acc158(73)=acc158(2)*Qspe3
      acc158(74)=acc158(15)*Qspe2
      acc158(75)=acc158(27)*acc158(71)
      acc158(76)=acc158(36)*Qspe4
      acc158(73)=acc158(54)+acc158(76)+acc158(75)+acc158(74)+acc158(73)
      acc158(73)=Qspvak1k3*acc158(73)
      acc158(74)=acc158(48)*Qspe4
      acc158(75)=acc158(60)*acc158(71)
      acc158(76)=acc158(61)*Qspk4
      acc158(79)=QspQ*Qspe2
      acc158(80)=acc158(64)*acc158(79)
      acc158(74)=acc158(80)+acc158(76)+acc158(75)+acc158(58)+acc158(74)
      acc158(74)=Qspvak1e3*acc158(74)
      acc158(75)=acc158(8)*Qspk4
      acc158(76)=acc158(37)*Qspe4
      acc158(75)=acc158(76)+acc158(75)
      acc158(75)=Qspvae2k5*acc158(75)
      acc158(76)=acc158(14)*Qspe3
      acc158(80)=acc158(66)*Qspe4
      acc158(76)=acc158(80)+acc158(76)+acc158(6)
      acc158(76)=Qspvak1k5*acc158(76)
      acc158(80)=acc158(12)*Qspe4
      acc158(81)=acc158(17)*Qspe3
      acc158(80)=acc158(81)+acc158(80)+acc158(7)
      acc158(80)=Qspk5*acc158(80)
      acc158(81)=acc158(29)*Qspvae4k5
      acc158(82)=acc158(32)*Qspvak1e4
      acc158(81)=acc158(82)+acc158(81)+acc158(23)
      acc158(79)=acc158(79)*acc158(81)
      acc158(81)=acc158(4)*Qspvak4k5*Qspe2
      acc158(71)=acc158(19)*Qspvak3k5*acc158(71)
      acc158(82)=acc158(31)*QspQ**2
      acc158(77)=acc158(38)*acc158(77)
      acc158(67)=acc158(49)*acc158(67)
      acc158(78)=acc158(59)*acc158(78)
      brack=acc158(67)+acc158(68)+acc158(69)+acc158(70)+acc158(71)+acc158(72)+a&
      &cc158(73)+acc158(74)+acc158(75)+acc158(76)+acc158(77)+acc158(78)+acc158(&
      &79)+acc158(80)+acc158(81)+acc158(82)
   end  function brack_1
!---#] function brack_1:
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use dgaad_groups, only: &
!           & sign => diagram158_sign, shift => diagram158_shift
      use dgaad_globalsl1, only: epspow
      use dgaad_kinematics
      use dgaad_abbrevd158h8
      implicit none
      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d158
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(0:3) :: qshift
      qshift = -k3-k4
      Q(1)  =cmplx(real(-Q_ext(4)  -qshift(0),  ki_sam),aimag(-Q_ext(4)),  ki)
      Q(2:4)=cmplx(real(-Q_ext(1:3)-qshift(1:3),ki_sam),aimag(-Q_ext(1:3)),ki)
      mu2    = cmplx(real(mu2_ext, ki), aimag(mu2_ext), ki)
      d158 = 0.0_ki
      d158 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d158, ki), aimag(d158), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use dgaad_globalsl1, only: epspow
      use dgaad_kinematics
      use dgaad_abbrevd158h8
      implicit none
      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d158
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(4) :: qshift
      qshift = -k3-k4
      Q(:)  =cmplx(real(-Q_ext(:)  -qshift(:),  ki_gol), 0.0_ki_gol, ki)
      mu2  = cmplx(real(mu2_ext, ki), 0.0_ki, ki)
      d158 = 0.0_ki
      d158 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d158, ki), aimag(d158), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module dgaad_d158h8l1
