module     ugaau_d157h0l1
   ! file: /.th/pcl340/scratch/gosam/greiner/ug_aau/helicity0d157h0l1.f90
   ! generator: buildfortran.py
   use ugaau_config, only: ki
   use ugaau_util, only: cond
   implicit none
   private
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ function brack_1:
   pure function brack_1(Q,mu2) result(brack)
      use ugaau_model
      use ugaau_kinematics
      use ugaau_color
      use ugaau_abbrevd157h0
      implicit none
      complex(ki), dimension(4), intent(in) :: Q
      complex(ki), intent(in) :: mu2
      complex(ki) :: brack
      complex(ki) :: acc157(84)
      complex(ki) :: Qspe2
      complex(ki) :: Qspe4
      complex(ki) :: Qspvae2k1
      complex(ki) :: Qspe3
      complex(ki) :: Qspvak3k1
      complex(ki) :: Qspk5
      complex(ki) :: Qspvak5e4
      complex(ki) :: Qspvae4k1
      complex(ki) :: Qspvae3k1
      complex(ki) :: Qspvak5k1
      complex(ki) :: QspQ
      complex(ki) :: Qspvak5e2
      complex(ki) :: Qspk3
      complex(ki) :: Qspk1
      complex(ki) :: Qspvak2k1
      complex(ki) :: Qspvak5k2
      complex(ki) :: Qspvak5k3
      complex(ki) :: Qspk2
      Qspe2 = dotproduct(Q,e2)
      Qspe4 = dotproduct(Q,e4)
      Qspvae2k1 = dotproduct(Q,spvae2k1)
      Qspe3 = dotproduct(Q,e3)
      Qspvak3k1 = dotproduct(Q,spvak3k1)
      Qspk5 = dotproduct(Q,k5)
      Qspvak5e4 = dotproduct(Q,spvak5e4)
      Qspvae4k1 = dotproduct(Q,spvae4k1)
      Qspvae3k1 = dotproduct(Q,spvae3k1)
      Qspvak5k1 = dotproduct(Q,spvak5k1)
      QspQ = dotproduct(Q,Q)
      Qspvak5e2 = dotproduct(Q,spvak5e2)
      Qspk3 = dotproduct(Q,k3)
      Qspk1 = dotproduct(Q,k1)
      Qspvak2k1 = dotproduct(Q,spvak2k1)
      Qspvak5k2 = dotproduct(Q,spvak5k2)
      Qspvak5k3 = dotproduct(Q,spvak5k3)
      Qspk2 = dotproduct(Q,k2)
      acc157(1)=abb157(2)
      acc157(2)=abb157(3)
      acc157(3)=abb157(4)
      acc157(4)=abb157(5)
      acc157(5)=abb157(6)
      acc157(6)=abb157(7)
      acc157(7)=abb157(8)
      acc157(8)=abb157(9)
      acc157(9)=abb157(10)
      acc157(10)=abb157(11)
      acc157(11)=abb157(12)
      acc157(12)=abb157(13)
      acc157(13)=abb157(14)
      acc157(14)=abb157(15)
      acc157(15)=abb157(16)
      acc157(16)=abb157(17)
      acc157(17)=abb157(18)
      acc157(18)=abb157(19)
      acc157(19)=abb157(20)
      acc157(20)=abb157(21)
      acc157(21)=abb157(22)
      acc157(22)=abb157(23)
      acc157(23)=abb157(24)
      acc157(24)=abb157(25)
      acc157(25)=abb157(26)
      acc157(26)=abb157(27)
      acc157(27)=abb157(28)
      acc157(28)=abb157(29)
      acc157(29)=abb157(30)
      acc157(30)=abb157(31)
      acc157(31)=abb157(32)
      acc157(32)=abb157(33)
      acc157(33)=abb157(34)
      acc157(34)=abb157(35)
      acc157(35)=abb157(36)
      acc157(36)=abb157(37)
      acc157(37)=abb157(38)
      acc157(38)=abb157(39)
      acc157(39)=abb157(40)
      acc157(40)=abb157(41)
      acc157(41)=abb157(42)
      acc157(42)=abb157(43)
      acc157(43)=abb157(44)
      acc157(44)=abb157(45)
      acc157(45)=abb157(46)
      acc157(46)=abb157(47)
      acc157(47)=abb157(48)
      acc157(48)=abb157(49)
      acc157(49)=abb157(50)
      acc157(50)=abb157(51)
      acc157(51)=abb157(52)
      acc157(52)=abb157(53)
      acc157(53)=abb157(55)
      acc157(54)=abb157(57)
      acc157(55)=abb157(58)
      acc157(56)=abb157(59)
      acc157(57)=abb157(60)
      acc157(58)=abb157(62)
      acc157(59)=abb157(63)
      acc157(60)=abb157(65)
      acc157(61)=abb157(66)
      acc157(62)=abb157(68)
      acc157(63)=abb157(70)
      acc157(64)=abb157(71)
      acc157(65)=abb157(73)
      acc157(66)=abb157(74)
      acc157(67)=abb157(75)
      acc157(68)=Qspe2*Qspe4
      acc157(69)=acc157(16)*acc157(68)
      acc157(70)=Qspvae2k1*Qspe3
      acc157(71)=acc157(18)*acc157(70)
      acc157(72)=acc157(20)*Qspvae2k1
      acc157(73)=acc157(23)*Qspe2
      acc157(74)=acc157(27)*Qspvak3k1
      acc157(75)=acc157(32)*Qspk5
      acc157(76)=acc157(38)*Qspvak5e4
      acc157(77)=Qspvak5e4*Qspe3
      acc157(78)=acc157(44)*acc157(77)
      acc157(79)=Qspvae4k1*Qspe3
      acc157(80)=acc157(51)*acc157(79)
      acc157(81)=acc157(57)*Qspvae3k1
      acc157(82)=acc157(64)*Qspvak5k1
      acc157(69)=acc157(82)+acc157(81)+acc157(80)+acc157(78)+acc157(76)+acc157(&
      &75)+acc157(74)+acc157(25)+acc157(73)+acc157(72)+acc157(71)+acc157(69)
      acc157(69)=QspQ*acc157(69)
      acc157(71)=acc157(65)*Qspe4
      acc157(71)=acc157(71)+acc157(58)
      acc157(71)=Qspvae2k1*acc157(71)
      acc157(72)=acc157(17)*Qspvak5e2*Qspe4
      acc157(73)=acc157(19)*Qspk5
      acc157(74)=acc157(39)*Qspvak5e4
      acc157(75)=acc157(59)*Qspvae3k1
      acc157(76)=Qspvae3k1*Qspe4
      acc157(78)=acc157(60)*acc157(76)
      acc157(80)=acc157(63)*Qspvak5k1
      acc157(71)=acc157(80)+acc157(78)+acc157(75)+acc157(74)+acc157(73)+acc157(&
      &72)+acc157(71)
      acc157(71)=Qspk3*acc157(71)
      acc157(72)=-acc157(3)*Qspe4
      acc157(72)=acc157(10)+acc157(72)
      acc157(72)=Qspvak5k1*acc157(72)
      acc157(73)=-Qspk1-Qspk5
      acc157(73)=acc157(15)*acc157(73)
      acc157(74)=acc157(11)*Qspvak2k1
      acc157(75)=-acc157(12)*Qspvak3k1
      acc157(78)=acc157(37)*Qspvak5e4
      acc157(80)=acc157(48)*Qspvae4k1
      acc157(72)=acc157(80)+acc157(78)+acc157(75)+acc157(74)+acc157(73)+acc157(&
      &72)
      acc157(72)=acc157(72)*Qspe2
      acc157(73)=acc157(35)*Qspvak2k1
      acc157(72)=acc157(73)+acc157(72)
      acc157(72)=Qspe3*acc157(72)
      acc157(73)=acc157(36)*Qspvak2k1
      acc157(74)=acc157(40)*Qspvak5k2
      acc157(75)=acc157(45)*Qspvak5e2
      acc157(78)=acc157(47)*Qspvae2k1
      acc157(80)=acc157(49)*Qspvak3k1
      acc157(81)=acc157(67)*Qspvak5k3
      acc157(73)=acc157(81)+acc157(80)+acc157(78)+acc157(75)+acc157(74)+acc157(&
      &73)
      acc157(73)=acc157(73)*Qspe3
      acc157(74)=acc157(26)*Qspvak5k3
      acc157(75)=acc157(42)*Qspvak5k2
      acc157(73)=acc157(75)+acc157(74)+acc157(73)
      acc157(73)=Qspe4*acc157(73)
      acc157(74)=-acc157(5)*Qspvak3k1
      acc157(75)=acc157(34)*QspQ
      acc157(78)=acc157(41)*acc157(77)
      acc157(79)=acc157(50)*acc157(79)
      acc157(80)=-acc157(66)*acc157(70)
      acc157(74)=acc157(80)+acc157(79)+acc157(78)+acc157(75)+acc157(74)
      acc157(75)=Qspk2-Qspk3
      acc157(74)=acc157(75)*acc157(74)
      acc157(75)=acc157(4)*Qspe2
      acc157(78)=acc157(8)*acc157(68)
      acc157(79)=acc157(21)*Qspe3
      acc157(80)=acc157(24)*Qspe4
      acc157(75)=acc157(80)+acc157(79)+acc157(78)+acc157(75)+acc157(1)
      acc157(75)=Qspvak3k1*acc157(75)
      acc157(78)=acc157(55)*Qspe2
      acc157(79)=acc157(56)*acc157(68)
      acc157(80)=acc157(61)*Qspk2
      acc157(81)=QspQ*Qspe4
      acc157(82)=acc157(62)*acc157(81)
      acc157(78)=acc157(82)+acc157(80)+acc157(79)+acc157(78)+acc157(53)
      acc157(78)=Qspvae3k1*acc157(78)
      acc157(79)=acc157(28)*Qspe2
      acc157(80)=acc157(43)*Qspk2
      acc157(79)=acc157(80)+acc157(79)
      acc157(79)=Qspvak5e4*acc157(79)
      acc157(80)=acc157(7)*Qspe3
      acc157(82)=acc157(52)*Qspe2
      acc157(80)=acc157(82)+acc157(80)+acc157(2)
      acc157(80)=Qspvak5k1*acc157(80)
      acc157(82)=acc157(9)*Qspe3
      acc157(83)=acc157(14)*Qspe2
      acc157(82)=acc157(83)+acc157(82)+acc157(6)
      acc157(82)=Qspk5*acc157(82)
      acc157(83)=-acc157(30)*Qspvae2k1
      acc157(84)=-acc157(31)*Qspvak5e2
      acc157(83)=acc157(84)+acc157(83)+acc157(29)
      acc157(81)=acc157(81)*acc157(83)
      acc157(68)=acc157(13)*Qspvak5k3*acc157(68)
      acc157(77)=acc157(22)*acc157(77)
      acc157(83)=acc157(33)*QspQ**2
      acc157(70)=acc157(46)*acc157(70)
      acc157(76)=acc157(54)*acc157(76)
      brack=acc157(68)+acc157(69)+acc157(70)+acc157(71)+acc157(72)+acc157(73)+a&
      &cc157(74)+acc157(75)+acc157(76)+acc157(77)+acc157(78)+acc157(79)+acc157(&
      &80)+acc157(81)+acc157(82)+acc157(83)
   end  function brack_1
!---#] function brack_1:
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use ugaau_groups, only: &
!           & sign => diagram157_sign, shift => diagram157_shift
      use ugaau_globalsl1, only: epspow
      use ugaau_kinematics
      use ugaau_abbrevd157h0
      implicit none
      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d157
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(0:3) :: qshift
      qshift = -k3
      Q(1)  =cmplx(real(-Q_ext(4)  -qshift(0),  ki_sam),aimag(-Q_ext(4)),  ki)
      Q(2:4)=cmplx(real(-Q_ext(1:3)-qshift(1:3),ki_sam),aimag(-Q_ext(1:3)),ki)
      mu2    = cmplx(real(mu2_ext, ki), aimag(mu2_ext), ki)
      d157 = 0.0_ki
      d157 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d157, ki), aimag(d157), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use ugaau_globalsl1, only: epspow
      use ugaau_kinematics
      use ugaau_abbrevd157h0
      implicit none
      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d157
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(4) :: qshift
      qshift = -k3
      Q(:)  =cmplx(real(-Q_ext(:)  -qshift(:),  ki_gol), 0.0_ki_gol, ki)
      mu2  = cmplx(real(mu2_ext, ki), 0.0_ki, ki)
      d157 = 0.0_ki
      d157 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d157, ki), aimag(d157), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module ugaau_d157h0l1
