module     ugaau_d160h0l1
   ! file: /.th/pcl340/scratch/gosam/greiner/ug_aau/helicity0d160h0l1.f90
   ! generator: buildfortran.py
   use ugaau_config, only: ki
   use ugaau_util, only: cond
   implicit none
   private
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ function brack_1:
   pure function brack_1(Q,mu2) result(brack)
      use ugaau_model
      use ugaau_kinematics
      use ugaau_color
      use ugaau_abbrevd160h0
      implicit none
      complex(ki), dimension(4), intent(in) :: Q
      complex(ki), intent(in) :: mu2
      complex(ki) :: brack
      complex(ki) :: acc160(82)
      complex(ki) :: Qspvae3k1
      complex(ki) :: Qspe4
      complex(ki) :: Qspe3
      complex(ki) :: Qspvak4k1
      complex(ki) :: Qspe2
      complex(ki) :: Qspk5
      complex(ki) :: Qspvak5e2
      complex(ki) :: Qspvak5k1
      complex(ki) :: Qspvae4k1
      complex(ki) :: Qspvae2k1
      complex(ki) :: QspQ
      complex(ki) :: Qspvak5k3
      complex(ki) :: Qspvak5e3
      complex(ki) :: Qspvak3k1
      complex(ki) :: Qspvak5k4
      complex(ki) :: Qspk1
      complex(ki) :: Qspk4
      complex(ki) :: Qspk3
      Qspvae3k1 = dotproduct(Q,spvae3k1)
      Qspe4 = dotproduct(Q,e4)
      Qspe3 = dotproduct(Q,e3)
      Qspvak4k1 = dotproduct(Q,spvak4k1)
      Qspe2 = dotproduct(Q,e2)
      Qspk5 = dotproduct(Q,k5)
      Qspvak5e2 = dotproduct(Q,spvak5e2)
      Qspvak5k1 = dotproduct(Q,spvak5k1)
      Qspvae4k1 = dotproduct(Q,spvae4k1)
      Qspvae2k1 = dotproduct(Q,spvae2k1)
      QspQ = dotproduct(Q,Q)
      Qspvak5k3 = dotproduct(Q,spvak5k3)
      Qspvak5e3 = dotproduct(Q,spvak5e3)
      Qspvak3k1 = dotproduct(Q,spvak3k1)
      Qspvak5k4 = dotproduct(Q,spvak5k4)
      Qspk1 = dotproduct(Q,k1)
      Qspk4 = dotproduct(Q,k4)
      Qspk3 = dotproduct(Q,k3)
      acc160(1)=abb160(2)
      acc160(2)=abb160(3)
      acc160(3)=abb160(4)
      acc160(4)=abb160(5)
      acc160(5)=abb160(6)
      acc160(6)=abb160(7)
      acc160(7)=abb160(8)
      acc160(8)=abb160(9)
      acc160(9)=abb160(10)
      acc160(10)=abb160(11)
      acc160(11)=abb160(12)
      acc160(12)=abb160(13)
      acc160(13)=abb160(14)
      acc160(14)=abb160(15)
      acc160(15)=abb160(16)
      acc160(16)=abb160(17)
      acc160(17)=abb160(18)
      acc160(18)=abb160(19)
      acc160(19)=abb160(20)
      acc160(20)=abb160(21)
      acc160(21)=abb160(22)
      acc160(22)=abb160(23)
      acc160(23)=abb160(24)
      acc160(24)=abb160(25)
      acc160(25)=abb160(26)
      acc160(26)=abb160(27)
      acc160(27)=abb160(28)
      acc160(28)=abb160(29)
      acc160(29)=abb160(30)
      acc160(30)=abb160(31)
      acc160(31)=abb160(32)
      acc160(32)=abb160(33)
      acc160(33)=abb160(34)
      acc160(34)=abb160(35)
      acc160(35)=abb160(36)
      acc160(36)=abb160(37)
      acc160(37)=abb160(38)
      acc160(38)=abb160(39)
      acc160(39)=abb160(40)
      acc160(40)=abb160(41)
      acc160(41)=abb160(42)
      acc160(42)=abb160(43)
      acc160(43)=abb160(44)
      acc160(44)=abb160(45)
      acc160(45)=abb160(46)
      acc160(46)=abb160(47)
      acc160(47)=abb160(48)
      acc160(48)=abb160(49)
      acc160(49)=abb160(50)
      acc160(50)=abb160(51)
      acc160(51)=abb160(52)
      acc160(52)=abb160(53)
      acc160(53)=abb160(54)
      acc160(54)=abb160(55)
      acc160(55)=abb160(57)
      acc160(56)=abb160(58)
      acc160(57)=abb160(59)
      acc160(58)=abb160(62)
      acc160(59)=abb160(63)
      acc160(60)=abb160(64)
      acc160(61)=abb160(66)
      acc160(62)=abb160(69)
      acc160(63)=abb160(71)
      acc160(64)=abb160(72)
      acc160(65)=abb160(73)
      acc160(66)=abb160(74)
      acc160(67)=Qspvae3k1*Qspe4
      acc160(68)=acc160(20)*acc160(67)
      acc160(69)=acc160(22)*Qspe3
      acc160(70)=acc160(24)*Qspvak4k1
      acc160(71)=Qspe3*Qspe2
      acc160(72)=acc160(26)*acc160(71)
      acc160(73)=acc160(28)*Qspk5
      acc160(74)=acc160(36)*Qspvak5e2
      acc160(75)=acc160(41)*Qspvak5k1
      acc160(76)=Qspvak5e2*Qspe4
      acc160(77)=acc160(42)*acc160(76)
      acc160(78)=acc160(46)*Qspvae4k1
      acc160(79)=acc160(56)*Qspvae3k1
      acc160(80)=Qspvae2k1*Qspe4
      acc160(81)=acc160(65)*acc160(80)
      acc160(68)=acc160(81)+acc160(79)+acc160(78)+acc160(77)+acc160(75)+acc160(&
      &74)+acc160(73)+acc160(72)+acc160(70)+acc160(69)+acc160(68)+acc160(8)
      acc160(68)=QspQ*acc160(68)
      acc160(69)=acc160(5)*Qspvak5k3
      acc160(70)=acc160(31)*Qspvak5e3
      acc160(72)=acc160(43)*Qspvak4k1
      acc160(73)=acc160(54)*Qspvak3k1
      acc160(74)=acc160(61)*Qspvae3k1
      acc160(75)=acc160(66)*Qspvak5k4
      acc160(69)=acc160(75)+acc160(74)+acc160(73)+acc160(72)+acc160(70)+acc160(&
      &69)
      acc160(69)=acc160(69)*Qspe2
      acc160(70)=-acc160(1)*Qspe2
      acc160(70)=acc160(38)+acc160(70)
      acc160(70)=Qspvak5k1*acc160(70)
      acc160(72)=-Qspk1-Qspk5
      acc160(72)=acc160(17)*acc160(72)
      acc160(73)=acc160(14)*Qspvak3k1
      acc160(74)=acc160(15)*Qspvak4k1
      acc160(75)=acc160(35)*Qspvak5e2
      acc160(77)=acc160(48)*Qspvae2k1
      acc160(70)=acc160(77)+acc160(75)+acc160(74)+acc160(73)+acc160(72)+acc160(&
      &70)
      acc160(70)=acc160(70)*Qspe3
      acc160(72)=acc160(53)*Qspvak3k1
      acc160(69)=acc160(72)+acc160(70)+acc160(69)
      acc160(69)=Qspe4*acc160(69)
      acc160(70)=acc160(63)*Qspe2
      acc160(70)=acc160(70)+acc160(59)
      acc160(70)=Qspvae3k1*acc160(70)
      acc160(72)=acc160(3)*Qspvak5e2
      acc160(73)=acc160(19)*Qspvak5e3*Qspe2
      acc160(74)=acc160(21)*Qspk5
      acc160(75)=acc160(44)*Qspvak5k1
      acc160(77)=acc160(57)*Qspvae4k1
      acc160(78)=Qspvae4k1*Qspe2
      acc160(79)=acc160(58)*acc160(78)
      acc160(70)=acc160(79)+acc160(77)+acc160(75)+acc160(74)+acc160(73)+acc160(&
      &72)+acc160(70)
      acc160(70)=Qspk4*acc160(70)
      acc160(72)=acc160(13)*acc160(80)
      acc160(73)=acc160(25)*Qspvak4k1
      acc160(74)=acc160(30)*QspQ
      acc160(75)=acc160(39)*acc160(76)
      acc160(77)=-acc160(62)*acc160(67)
      acc160(72)=acc160(77)+acc160(75)+acc160(74)+acc160(73)+acc160(72)
      acc160(73)=Qspk3+Qspk4
      acc160(72)=acc160(73)*acc160(72)
      acc160(73)=acc160(2)*Qspe4
      acc160(74)=acc160(23)*Qspe3
      acc160(75)=acc160(33)*Qspe2
      acc160(77)=acc160(50)*acc160(71)
      acc160(73)=acc160(77)+acc160(45)+acc160(75)+acc160(74)+acc160(73)
      acc160(73)=Qspvak4k1*acc160(73)
      acc160(74)=acc160(40)*Qspk3
      acc160(75)=acc160(49)*Qspe3
      acc160(77)=acc160(52)*acc160(71)
      acc160(79)=QspQ*Qspe2
      acc160(80)=acc160(55)*acc160(79)
      acc160(74)=acc160(80)+acc160(77)+acc160(75)+acc160(47)+acc160(74)
      acc160(74)=Qspvae4k1*acc160(74)
      acc160(75)=acc160(34)*Qspe3
      acc160(77)=acc160(37)*Qspk3
      acc160(75)=acc160(77)+acc160(75)
      acc160(75)=Qspvak5e2*acc160(75)
      acc160(77)=acc160(9)*Qspe4
      acc160(80)=acc160(11)*Qspe3
      acc160(77)=acc160(80)+acc160(77)+acc160(6)
      acc160(77)=Qspvak5k1*acc160(77)
      acc160(80)=acc160(12)*Qspe4
      acc160(81)=acc160(16)*Qspe3
      acc160(80)=acc160(81)+acc160(80)+acc160(7)
      acc160(80)=Qspk5*acc160(80)
      acc160(81)=-acc160(27)*Qspvak5e3
      acc160(82)=acc160(64)*Qspvae3k1
      acc160(81)=acc160(82)+acc160(81)+acc160(10)
      acc160(79)=acc160(79)*acc160(81)
      acc160(81)=acc160(4)*Qspvak5k3*Qspe2
      acc160(71)=acc160(18)*Qspvak5k4*acc160(71)
      acc160(82)=acc160(29)*QspQ**2
      acc160(76)=acc160(32)*acc160(76)
      acc160(78)=acc160(51)*acc160(78)
      acc160(67)=acc160(60)*acc160(67)
      brack=acc160(67)+acc160(68)+acc160(69)+acc160(70)+acc160(71)+acc160(72)+a&
      &cc160(73)+acc160(74)+acc160(75)+acc160(76)+acc160(77)+acc160(78)+acc160(&
      &79)+acc160(80)+acc160(81)+acc160(82)
   end  function brack_1
!---#] function brack_1:
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use ugaau_groups, only: &
!           & sign => diagram160_sign, shift => diagram160_shift
      use ugaau_globalsl1, only: epspow
      use ugaau_kinematics
      use ugaau_abbrevd160h0
      implicit none
      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d160
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(0:3) :: qshift
      qshift = -k3-k4
      Q(1)  =cmplx(real(-Q_ext(4)  -qshift(0),  ki_sam),aimag(-Q_ext(4)),  ki)
      Q(2:4)=cmplx(real(-Q_ext(1:3)-qshift(1:3),ki_sam),aimag(-Q_ext(1:3)),ki)
      mu2    = cmplx(real(mu2_ext, ki), aimag(mu2_ext), ki)
      d160 = 0.0_ki
      d160 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d160, ki), aimag(d160), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use ugaau_globalsl1, only: epspow
      use ugaau_kinematics
      use ugaau_abbrevd160h0
      implicit none
      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d160
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(4) :: qshift
      qshift = -k3-k4
      Q(:)  =cmplx(real(-Q_ext(:)  -qshift(:),  ki_gol), 0.0_ki_gol, ki)
      mu2  = cmplx(real(mu2_ext, ki), 0.0_ki, ki)
      d160 = 0.0_ki
      d160 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d160, ki), aimag(d160), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module ugaau_d160h0l1
