module     ugaau_d63h0l1
   ! file: /.th/pcl340/scratch/gosam/greiner/ug_aau/helicity0d63h0l1.f90
   ! generator: buildfortran.py
   use ugaau_config, only: ki
   use ugaau_util, only: cond
   implicit none
   private
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ function brack_1:
   pure function brack_1(Q,mu2) result(brack)
      use ugaau_model
      use ugaau_kinematics
      use ugaau_color
      use ugaau_abbrevd63h0
      implicit none
      complex(ki), dimension(4), intent(in) :: Q
      complex(ki), intent(in) :: mu2
      complex(ki) :: brack
      complex(ki) :: acc63(41)
      complex(ki) :: Qspvak4k1
      complex(ki) :: Qspvak3e2
      complex(ki) :: Qspvak5k4
      complex(ki) :: Qspvak5e2
      complex(ki) :: Qspvak3k4
      complex(ki) :: Qspvae2k1
      complex(ki) :: Qspvak3k2
      complex(ki) :: Qspvak5k2
      complex(ki) :: Qspvak2k1
      complex(ki) :: Qspe4
      complex(ki) :: Qspvak5k1
      complex(ki) :: Qspvak3k1
      complex(ki) :: Qspvae4k1
      complex(ki) :: Qspe2
      complex(ki) :: QspQ
      complex(ki) :: Qspk4
      Qspvak4k1 = dotproduct(Q,spvak4k1)
      Qspvak3e2 = dotproduct(Q,spvak3e2)
      Qspvak5k4 = dotproduct(Q,spvak5k4)
      Qspvak5e2 = dotproduct(Q,spvak5e2)
      Qspvak3k4 = dotproduct(Q,spvak3k4)
      Qspvae2k1 = dotproduct(Q,spvae2k1)
      Qspvak3k2 = dotproduct(Q,spvak3k2)
      Qspvak5k2 = dotproduct(Q,spvak5k2)
      Qspvak2k1 = dotproduct(Q,spvak2k1)
      Qspe4 = dotproduct(Q,e4)
      Qspvak5k1 = dotproduct(Q,spvak5k1)
      Qspvak3k1 = dotproduct(Q,spvak3k1)
      Qspvae4k1 = dotproduct(Q,spvae4k1)
      Qspe2 = dotproduct(Q,e2)
      QspQ = dotproduct(Q,Q)
      Qspk4 = dotproduct(Q,k4)
      acc63(1)=abb63(3)
      acc63(2)=abb63(4)
      acc63(3)=abb63(5)
      acc63(4)=abb63(6)
      acc63(5)=abb63(7)
      acc63(6)=abb63(8)
      acc63(7)=abb63(9)
      acc63(8)=abb63(10)
      acc63(9)=abb63(11)
      acc63(10)=abb63(12)
      acc63(11)=abb63(13)
      acc63(12)=abb63(14)
      acc63(13)=abb63(15)
      acc63(14)=abb63(16)
      acc63(15)=abb63(17)
      acc63(16)=abb63(18)
      acc63(17)=abb63(19)
      acc63(18)=abb63(20)
      acc63(19)=abb63(21)
      acc63(20)=abb63(22)
      acc63(21)=abb63(23)
      acc63(22)=abb63(24)
      acc63(23)=abb63(25)
      acc63(24)=abb63(26)
      acc63(25)=abb63(27)
      acc63(26)=abb63(28)
      acc63(27)=abb63(29)
      acc63(28)=abb63(30)
      acc63(29)=abb63(32)
      acc63(30)=abb63(33)
      acc63(31)=abb63(37)
      acc63(32)=acc63(7)*Qspvak4k1
      acc63(33)=acc63(10)*Qspvak3e2
      acc63(34)=acc63(11)*Qspvak5k4
      acc63(35)=acc63(12)*Qspvak5e2
      acc63(36)=acc63(16)*Qspvak3k4
      acc63(37)=acc63(21)*Qspvae2k1
      acc63(38)=acc63(23)*Qspvak3k2
      acc63(39)=acc63(31)*Qspvak5k2
      acc63(40)=Qspvak2k1*acc63(25)
      acc63(32)=acc63(40)+acc63(39)+acc63(38)+acc63(37)+acc63(36)+acc63(35)+acc&
      &63(34)+acc63(33)+acc63(32)
      acc63(32)=Qspe4*acc63(32)
      acc63(33)=Qspvak5k1*acc63(2)
      acc63(34)=Qspvak3k1*acc63(3)
      acc63(33)=acc63(34)+acc63(33)
      acc63(33)=acc63(33)*Qspe4
      acc63(34)=acc63(8)*Qspvak4k1
      acc63(35)=acc63(13)*Qspvak5k4
      acc63(36)=acc63(17)*Qspvak3k4
      acc63(37)=acc63(24)*Qspvae4k1
      acc63(33)=acc63(33)+acc63(37)+acc63(36)+acc63(35)+acc63(34)
      acc63(33)=Qspe2*acc63(33)
      acc63(34)=acc63(5)*Qspvae2k1
      acc63(35)=acc63(9)*Qspe2
      acc63(36)=acc63(14)*Qspvak5e2
      acc63(37)=acc63(18)*Qspvak3e2
      acc63(38)=acc63(26)*Qspvae4k1
      acc63(34)=acc63(38)+acc63(37)+acc63(36)+acc63(35)+acc63(34)+acc63(1)
      acc63(34)=QspQ*acc63(34)
      acc63(35)=acc63(15)*Qspvak5e2
      acc63(36)=acc63(19)*Qspvak3e2
      acc63(37)=acc63(27)*Qspvae4k1
      acc63(38)=acc63(28)*Qspvae2k1
      acc63(35)=acc63(38)+acc63(37)+acc63(36)+acc63(35)
      acc63(35)=Qspk4*acc63(35)
      acc63(36)=acc63(4)*Qspvak4k1
      acc63(37)=acc63(6)*Qspvae4k1
      acc63(38)=acc63(20)*Qspvak3k2
      acc63(39)=acc63(22)*Qspvak3k4
      acc63(40)=acc63(29)*Qspvak5k2
      acc63(41)=acc63(30)*Qspvak5k4
      brack=acc63(32)+acc63(33)+acc63(34)+acc63(35)+acc63(36)+acc63(37)+acc63(3&
      &8)+acc63(39)+acc63(40)+acc63(41)
   end  function brack_1
!---#] function brack_1:
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use ugaau_groups, only: &
!           & sign => diagram63_sign, shift => diagram63_shift
      use ugaau_globalsl1, only: epspow
      use ugaau_kinematics
      use ugaau_abbrevd63h0
      implicit none
      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d63
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(0:3) :: qshift
      qshift = -k2+k4
      Q(1)  =cmplx(real(-Q_ext(4)  -qshift(0),  ki_sam),aimag(-Q_ext(4)),  ki)
      Q(2:4)=cmplx(real(-Q_ext(1:3)-qshift(1:3),ki_sam),aimag(-Q_ext(1:3)),ki)
      mu2    = cmplx(real(mu2_ext, ki), aimag(mu2_ext), ki)
      d63 = 0.0_ki
      d63 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d63, ki), aimag(d63), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use ugaau_globalsl1, only: epspow
      use ugaau_kinematics
      use ugaau_abbrevd63h0
      implicit none
      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d63
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(4) :: qshift
      qshift = -k2+k4
      Q(:)  =cmplx(real(-Q_ext(:)  -qshift(:),  ki_gol), 0.0_ki_gol, ki)
      mu2  = cmplx(real(mu2_ext, ki), 0.0_ki, ki)
      d63 = 0.0_ki
      d63 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d63, ki), aimag(d63), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module ugaau_d63h0l1
