module     ugaau_d153h8l1
   ! file: /.th/pcl340/scratch/gosam/greiner/ug_aau/helicity8d153h8l1.f90
   ! generator: buildfortran.py
   use ugaau_config, only: ki
   use ugaau_util, only: cond
   implicit none
   private
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ function brack_1:
   pure function brack_1(Q,mu2) result(brack)
      use ugaau_model
      use ugaau_kinematics
      use ugaau_color
      use ugaau_abbrevd153h8
      implicit none
      complex(ki), dimension(4), intent(in) :: Q
      complex(ki), intent(in) :: mu2
      complex(ki) :: brack
      complex(ki) :: acc153(88)
      complex(ki) :: Qspk2
      complex(ki) :: Qspk5
      complex(ki) :: Qspvak2k5
      complex(ki) :: Qspvak1k3
      complex(ki) :: Qspvak1k5
      complex(ki) :: Qspvak1e4
      complex(ki) :: Qspvae4k5
      complex(ki) :: Qspvak1k2
      complex(ki) :: Qspk1
      complex(ki) :: QspQ
      complex(ki) :: Qspe4
      complex(ki) :: Qspe3
      complex(ki) :: Qspvak3k5
      complex(ki) :: Qspvak1e3
      complex(ki) :: Qspk3
      complex(ki) :: Qspe2
      complex(ki) :: Qspvak1e2
      Qspk2 = dotproduct(Q,k2)
      Qspk5 = dotproduct(Q,k5)
      Qspvak2k5 = dotproduct(Q,spvak2k5)
      Qspvak1k3 = dotproduct(Q,spvak1k3)
      Qspvak1k5 = dotproduct(Q,spvak1k5)
      Qspvak1e4 = dotproduct(Q,spvak1e4)
      Qspvae4k5 = dotproduct(Q,spvae4k5)
      Qspvak1k2 = dotproduct(Q,spvak1k2)
      Qspk1 = dotproduct(Q,k1)
      QspQ = dotproduct(Q,Q)
      Qspe4 = dotproduct(Q,e4)
      Qspe3 = dotproduct(Q,e3)
      Qspvak3k5 = dotproduct(Q,spvak3k5)
      Qspvak1e3 = dotproduct(Q,spvak1e3)
      Qspk3 = dotproduct(Q,k3)
      Qspe2 = dotproduct(Q,e2)
      Qspvak1e2 = dotproduct(Q,spvak1e2)
      acc153(1)=abb153(1)
      acc153(2)=abb153(2)
      acc153(3)=abb153(3)
      acc153(4)=abb153(4)
      acc153(5)=abb153(5)
      acc153(6)=abb153(6)
      acc153(7)=abb153(7)
      acc153(8)=abb153(8)
      acc153(9)=abb153(9)
      acc153(10)=abb153(10)
      acc153(11)=abb153(11)
      acc153(12)=abb153(12)
      acc153(13)=abb153(13)
      acc153(14)=abb153(14)
      acc153(15)=abb153(15)
      acc153(16)=abb153(16)
      acc153(17)=abb153(17)
      acc153(18)=abb153(18)
      acc153(19)=abb153(19)
      acc153(20)=abb153(20)
      acc153(21)=abb153(21)
      acc153(22)=abb153(22)
      acc153(23)=abb153(23)
      acc153(24)=abb153(24)
      acc153(25)=abb153(25)
      acc153(26)=abb153(26)
      acc153(27)=abb153(27)
      acc153(28)=abb153(28)
      acc153(29)=abb153(29)
      acc153(30)=abb153(30)
      acc153(31)=abb153(31)
      acc153(32)=abb153(32)
      acc153(33)=abb153(33)
      acc153(34)=abb153(35)
      acc153(35)=abb153(36)
      acc153(36)=abb153(37)
      acc153(37)=abb153(38)
      acc153(38)=abb153(39)
      acc153(39)=abb153(40)
      acc153(40)=abb153(42)
      acc153(41)=abb153(43)
      acc153(42)=abb153(44)
      acc153(43)=abb153(45)
      acc153(44)=abb153(46)
      acc153(45)=abb153(47)
      acc153(46)=abb153(48)
      acc153(47)=abb153(49)
      acc153(48)=abb153(50)
      acc153(49)=abb153(51)
      acc153(50)=abb153(52)
      acc153(51)=abb153(53)
      acc153(52)=abb153(54)
      acc153(53)=abb153(55)
      acc153(54)=abb153(56)
      acc153(55)=abb153(58)
      acc153(56)=abb153(59)
      acc153(57)=abb153(60)
      acc153(58)=abb153(61)
      acc153(59)=abb153(62)
      acc153(60)=abb153(63)
      acc153(61)=abb153(64)
      acc153(62)=abb153(65)
      acc153(63)=abb153(66)
      acc153(64)=abb153(67)
      acc153(65)=abb153(70)
      acc153(66)=abb153(71)
      acc153(67)=abb153(72)
      acc153(68)=abb153(73)
      acc153(69)=abb153(74)
      acc153(70)=abb153(75)
      acc153(71)=abb153(76)
      acc153(72)=abb153(77)
      acc153(73)=abb153(78)
      acc153(74)=abb153(79)
      acc153(75)=abb153(80)
      acc153(76)=abb153(81)
      acc153(77)=abb153(82)
      acc153(78)=Qspk2+Qspk5
      acc153(79)=acc153(39)*acc153(78)
      acc153(80)=Qspvak2k5*acc153(55)
      acc153(81)=Qspvak1k3*acc153(62)
      acc153(82)=Qspvak1k5*acc153(75)
      acc153(83)=Qspvak1e4*acc153(76)
      acc153(84)=Qspvae4k5*acc153(20)
      acc153(85)=Qspvak1k2*acc153(23)
      acc153(86)=Qspk1*acc153(65)
      acc153(87)=QspQ*acc153(18)
      acc153(88)=-Qspvak1k5*acc153(36)
      acc153(88)=acc153(38)+acc153(88)
      acc153(88)=Qspe4*acc153(88)
      acc153(79)=acc153(88)+acc153(87)+acc153(86)+acc153(85)+acc153(84)+acc153(&
      &83)+acc153(82)+acc153(81)+acc153(31)+acc153(80)+acc153(79)
      acc153(79)=Qspe3*acc153(79)
      acc153(80)=acc153(45)*Qspvak3k5
      acc153(81)=Qspvak1k3*acc153(22)
      acc153(82)=Qspvak1k5*acc153(34)
      acc153(83)=Qspvak1e3*acc153(43)
      acc153(84)=Qspk1*acc153(63)
      acc153(85)=QspQ*acc153(72)
      acc153(80)=acc153(85)+acc153(84)+acc153(83)+acc153(82)+acc153(81)+acc153(&
      &80)+acc153(33)
      acc153(80)=Qspe4*acc153(80)
      acc153(81)=Qspvak1e4*acc153(77)
      acc153(82)=Qspvae4k5*acc153(73)
      acc153(83)=Qspvak1e3*acc153(58)
      acc153(81)=-acc153(83)+acc153(81)+acc153(82)
      acc153(82)=acc153(46)+acc153(81)
      acc153(82)=Qspk3*acc153(82)
      acc153(81)=acc153(44)-acc153(81)
      acc153(81)=Qspk1*acc153(81)
      acc153(83)=Qspvak1e4*acc153(71)
      acc153(84)=Qspvae4k5*acc153(66)
      acc153(85)=Qspvak1e3*acc153(53)
      acc153(83)=acc153(85)+acc153(84)+acc153(27)+acc153(83)
      acc153(83)=QspQ*acc153(83)
      acc153(78)=-acc153(3)*acc153(78)
      acc153(84)=Qspvak2k5*acc153(26)
      acc153(85)=Qspvak1k3*acc153(14)
      acc153(86)=Qspvak1e3*acc153(28)
      acc153(78)=acc153(79)+acc153(80)+acc153(83)+acc153(81)+acc153(82)+acc153(&
      &86)+acc153(85)+acc153(29)+acc153(84)+acc153(78)
      acc153(78)=Qspe2*acc153(78)
      acc153(79)=Qspk1-Qspk2
      acc153(79)=acc153(68)*acc153(79)
      acc153(80)=Qspk5*acc153(59)
      acc153(81)=Qspvak1k2*acc153(9)
      acc153(82)=Qspvak1e3*acc153(8)
      acc153(83)=Qspk3*acc153(40)
      acc153(84)=Qspvak1e2*acc153(7)
      acc153(85)=QspQ*acc153(50)
      acc153(79)=acc153(85)+acc153(84)+acc153(83)+acc153(82)+acc153(81)+acc153(&
      &52)+acc153(80)+acc153(79)
      acc153(79)=QspQ*acc153(79)
      acc153(80)=-Qspk1+Qspk3
      acc153(80)=acc153(41)*acc153(80)
      acc153(81)=Qspvak1k2*acc153(15)
      acc153(82)=Qspk5*acc153(67)
      acc153(83)=Qspvak1e3*acc153(64)
      acc153(84)=Qspk2*acc153(69)
      acc153(85)=Qspvak1e2*acc153(54)
      acc153(80)=acc153(85)+acc153(84)+acc153(83)-acc153(81)+acc153(60)+acc153(&
      &82)+acc153(80)
      acc153(80)=Qspk1*acc153(80)
      acc153(82)=Qspvak1k2*acc153(11)
      acc153(83)=Qspk2*acc153(49)
      acc153(84)=Qspvak1e2*acc153(35)
      acc153(85)=-Qspk1*acc153(24)
      acc153(86)=QspQ*acc153(70)
      acc153(82)=acc153(86)+acc153(85)+acc153(84)+acc153(83)+acc153(25)+acc153(&
      &82)
      acc153(82)=Qspe4*acc153(82)
      acc153(83)=Qspvak1k2*acc153(5)
      acc153(84)=Qspk2*acc153(48)
      acc153(85)=Qspk2-Qspk5
      acc153(86)=-acc153(37)*acc153(85)
      acc153(86)=acc153(30)+acc153(86)
      acc153(86)=Qspvak1e2*acc153(86)
      acc153(87)=Qspk1*acc153(19)
      acc153(88)=Qspvak1e2*acc153(12)
      acc153(88)=acc153(17)+acc153(88)
      acc153(88)=QspQ*acc153(88)
      acc153(82)=acc153(82)+acc153(88)+acc153(87)+acc153(86)+acc153(84)+acc153(&
      &21)+acc153(83)
      acc153(82)=Qspe3*acc153(82)
      acc153(83)=Qspvak1k2*acc153(6)
      acc153(84)=Qspk2*acc153(47)
      acc153(86)=Qspvak1e2*acc153(32)
      acc153(87)=Qspvak1e3*acc153(74)
      acc153(87)=acc153(61)+acc153(87)
      acc153(87)=Qspk1*acc153(87)
      acc153(88)=Qspvak1e3*acc153(56)
      acc153(88)=acc153(13)+acc153(88)
      acc153(88)=QspQ*acc153(88)
      acc153(83)=acc153(88)+acc153(87)+acc153(86)+acc153(84)+acc153(16)+acc153(&
      &83)
      acc153(83)=Qspe4*acc153(83)
      acc153(84)=acc153(1)*acc153(85)
      acc153(85)=-Qspk3*acc153(54)
      acc153(84)=acc153(85)+acc153(57)+acc153(84)
      acc153(84)=Qspvak1e2*acc153(84)
      acc153(85)=Qspvak1k2*acc153(2)
      acc153(81)=acc153(42)+acc153(81)
      acc153(81)=Qspk3*acc153(81)
      acc153(86)=Qspk3*acc153(51)
      acc153(86)=acc153(4)+acc153(86)
      acc153(86)=Qspk2*acc153(86)
      brack=acc153(10)+acc153(78)+acc153(79)+acc153(80)+acc153(81)+acc153(82)+a&
      &cc153(83)+acc153(84)+acc153(85)+acc153(86)
   end  function brack_1
!---#] function brack_1:
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use ugaau_groups, only: &
!           & sign => diagram153_sign, shift => diagram153_shift
      use ugaau_globalsl1, only: epspow
      use ugaau_kinematics
      use ugaau_abbrevd153h8
      implicit none
      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d153
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(0:3) :: qshift
      qshift = k2
      Q(1)  =cmplx(real(+Q_ext(4)  -qshift(0),  ki_sam),aimag(+Q_ext(4)),  ki)
      Q(2:4)=cmplx(real(+Q_ext(1:3)-qshift(1:3),ki_sam),aimag(+Q_ext(1:3)),ki)
      mu2    = cmplx(real(mu2_ext, ki), aimag(mu2_ext), ki)
      d153 = 0.0_ki
      d153 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d153, ki), aimag(d153), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use ugaau_globalsl1, only: epspow
      use ugaau_kinematics
      use ugaau_abbrevd153h8
      implicit none
      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d153
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(4) :: qshift
      qshift = k2
      Q(:)  =cmplx(real(+Q_ext(:)  -qshift(:),  ki_gol), 0.0_ki_gol, ki)
      mu2  = cmplx(real(mu2_ext, ki), 0.0_ki, ki)
      d153 = 0.0_ki
      d153 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d153, ki), aimag(d153), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module ugaau_d153h8l1
