module     ugaau_d66h8l1
   ! file: /.th/pcl340/scratch/gosam/greiner/ug_aau/helicity8d66h8l1.f90
   ! generator: buildfortran.py
   use ugaau_config, only: ki
   use ugaau_util, only: cond
   implicit none
   private
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ function brack_1:
   pure function brack_1(Q,mu2) result(brack)
      use ugaau_model
      use ugaau_kinematics
      use ugaau_color
      use ugaau_abbrevd66h8
      implicit none
      complex(ki), dimension(4), intent(in) :: Q
      complex(ki), intent(in) :: mu2
      complex(ki) :: brack
      complex(ki) :: acc66(41)
      complex(ki) :: Qspvak1k3
      complex(ki) :: Qspvae2k4
      complex(ki) :: Qspvak3k5
      complex(ki) :: Qspvae2k5
      complex(ki) :: Qspvak3k4
      complex(ki) :: Qspvak1e2
      complex(ki) :: Qspvak2k4
      complex(ki) :: Qspvak2k5
      complex(ki) :: Qspvak1k2
      complex(ki) :: Qspe3
      complex(ki) :: Qspvak1k5
      complex(ki) :: Qspvak1k4
      complex(ki) :: Qspvak1e3
      complex(ki) :: Qspe2
      complex(ki) :: QspQ
      complex(ki) :: Qspk3
      Qspvak1k3 = dotproduct(Q,spvak1k3)
      Qspvae2k4 = dotproduct(Q,spvae2k4)
      Qspvak3k5 = dotproduct(Q,spvak3k5)
      Qspvae2k5 = dotproduct(Q,spvae2k5)
      Qspvak3k4 = dotproduct(Q,spvak3k4)
      Qspvak1e2 = dotproduct(Q,spvak1e2)
      Qspvak2k4 = dotproduct(Q,spvak2k4)
      Qspvak2k5 = dotproduct(Q,spvak2k5)
      Qspvak1k2 = dotproduct(Q,spvak1k2)
      Qspe3 = dotproduct(Q,e3)
      Qspvak1k5 = dotproduct(Q,spvak1k5)
      Qspvak1k4 = dotproduct(Q,spvak1k4)
      Qspvak1e3 = dotproduct(Q,spvak1e3)
      Qspe2 = dotproduct(Q,e2)
      QspQ = dotproduct(Q,Q)
      Qspk3 = dotproduct(Q,k3)
      acc66(1)=abb66(3)
      acc66(2)=abb66(4)
      acc66(3)=abb66(5)
      acc66(4)=abb66(6)
      acc66(5)=abb66(7)
      acc66(6)=abb66(8)
      acc66(7)=abb66(9)
      acc66(8)=abb66(10)
      acc66(9)=abb66(11)
      acc66(10)=abb66(12)
      acc66(11)=abb66(13)
      acc66(12)=abb66(14)
      acc66(13)=abb66(15)
      acc66(14)=abb66(16)
      acc66(15)=abb66(17)
      acc66(16)=abb66(18)
      acc66(17)=abb66(19)
      acc66(18)=abb66(20)
      acc66(19)=abb66(21)
      acc66(20)=abb66(22)
      acc66(21)=abb66(23)
      acc66(22)=abb66(26)
      acc66(23)=abb66(28)
      acc66(24)=abb66(29)
      acc66(25)=abb66(30)
      acc66(26)=abb66(31)
      acc66(27)=abb66(32)
      acc66(28)=abb66(33)
      acc66(29)=abb66(34)
      acc66(30)=abb66(35)
      acc66(31)=abb66(36)
      acc66(32)=acc66(7)*Qspvak1k3
      acc66(33)=acc66(10)*Qspvae2k4
      acc66(34)=acc66(11)*Qspvak3k5
      acc66(35)=acc66(12)*Qspvae2k5
      acc66(36)=acc66(16)*Qspvak3k4
      acc66(37)=acc66(21)*Qspvak1e2
      acc66(38)=acc66(29)*Qspvak2k4
      acc66(39)=acc66(30)*Qspvak2k5
      acc66(40)=Qspvak1k2*acc66(20)
      acc66(32)=acc66(40)+acc66(39)+acc66(38)+acc66(37)+acc66(36)+acc66(35)+acc&
      &66(34)+acc66(33)+acc66(32)
      acc66(32)=Qspe3*acc66(32)
      acc66(33)=Qspvak1k5*acc66(2)
      acc66(34)=Qspvak1k4*acc66(3)
      acc66(33)=acc66(34)+acc66(33)
      acc66(33)=acc66(33)*Qspe3
      acc66(34)=acc66(8)*Qspvak1k3
      acc66(35)=acc66(13)*Qspvak3k5
      acc66(36)=acc66(17)*Qspvak3k4
      acc66(37)=acc66(22)*Qspvak1e3
      acc66(33)=acc66(33)+acc66(37)+acc66(36)+acc66(35)+acc66(34)
      acc66(33)=Qspe2*acc66(33)
      acc66(34)=acc66(5)*Qspvak1e2
      acc66(35)=acc66(9)*Qspe2
      acc66(36)=acc66(14)*Qspvae2k5
      acc66(37)=acc66(18)*Qspvae2k4
      acc66(38)=acc66(23)*Qspvak1e3
      acc66(34)=acc66(38)+acc66(37)+acc66(36)+acc66(35)+acc66(34)+acc66(1)
      acc66(34)=QspQ*acc66(34)
      acc66(35)=acc66(15)*Qspvae2k5
      acc66(36)=acc66(19)*Qspvae2k4
      acc66(37)=acc66(24)*Qspvak1e3
      acc66(38)=acc66(25)*Qspvak1e2
      acc66(35)=acc66(38)+acc66(37)+acc66(36)+acc66(35)
      acc66(35)=Qspk3*acc66(35)
      acc66(36)=acc66(4)*Qspvak1k3
      acc66(37)=acc66(6)*Qspvak1e3
      acc66(38)=acc66(26)*Qspvak2k4
      acc66(39)=acc66(27)*Qspvak2k5
      acc66(40)=acc66(28)*Qspvak3k5
      acc66(41)=acc66(31)*Qspvak3k4
      brack=acc66(32)+acc66(33)+acc66(34)+acc66(35)+acc66(36)+acc66(37)+acc66(3&
      &8)+acc66(39)+acc66(40)+acc66(41)
   end  function brack_1
!---#] function brack_1:
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use ugaau_groups, only: &
!           & sign => diagram66_sign, shift => diagram66_shift
      use ugaau_globalsl1, only: epspow
      use ugaau_kinematics
      use ugaau_abbrevd66h8
      implicit none
      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d66
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(0:3) :: qshift
      qshift = k3
      Q(1)  =cmplx(real(+Q_ext(4)  -qshift(0),  ki_sam),aimag(+Q_ext(4)),  ki)
      Q(2:4)=cmplx(real(+Q_ext(1:3)-qshift(1:3),ki_sam),aimag(+Q_ext(1:3)),ki)
      mu2    = cmplx(real(mu2_ext, ki), aimag(mu2_ext), ki)
      d66 = 0.0_ki
      d66 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d66, ki), aimag(d66), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use ugaau_globalsl1, only: epspow
      use ugaau_kinematics
      use ugaau_abbrevd66h8
      implicit none
      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d66
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(4) :: qshift
      qshift = k3
      Q(:)  =cmplx(real(+Q_ext(:)  -qshift(:),  ki_gol), 0.0_ki_gol, ki)
      mu2  = cmplx(real(mu2_ext, ki), 0.0_ki, ki)
      d66 = 0.0_ki
      d66 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d66, ki), aimag(d66), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module ugaau_d66h8l1
