      LOGICAL FUNCTION PASSCUTSDIP(P,j)
      IMPLICIT NONE
      include "nexternal.inc"
      include "jets.inc"
      include "run.inc"
      include "coupl.inc"
      DOUBLE PRECISION P(0:3,NEXTERNAL), P1(0:3,NEXTERNAL), P2(0:3,NEXTERNAL), jetp(4,NEXTERNAL),pt
      integer i,j,nu,njets,k
      logical debug, jetcut,notgood
      double precision pres(0:3,nexternal)
      common/res_mom/pres
      double precision etmin(nincoming+1:nexternal),etamax(nincoming+1:nexternal)
      double precision emin(nincoming+1:nexternal)
      double precision r2min(nincoming+1:nexternal,nincoming+1:nexternal)
      double precision s_min(nexternal,nexternal)
      double precision etmax(nincoming+1:nexternal),etamin(nincoming+1:nexternal)
      double precision emax(nincoming+1:nexternal)
      double precision r2max(nincoming+1:nexternal,nincoming+1:nexternal)
      double precision s_max(nexternal,nexternal),sumdot,tmp,alphaspdf
      common/to_cuts/  etmin, emin, etamax, r2min, s_min,
     $     etmax, emax, etamin, r2max, s_max
      real*8 PI
      parameter( PI = 3.14159265358979323846d0 )



      passcutsdip=.true.

c      do i=1,nexternal
c       if (i.lt.j) then
c        do nu=0,3
c         p1(nu,i)=p(nu,i)
c         pres(nu,i)=p1(nu,i)
c        enddo
c       elseif (i.eq.j) then
c        do nu=0,3
c         p1(nu,i)=0d0
c         pres(nu,i)=p1(nu,i)
c        enddo
c       elseif (i.gt.j) then
c        do nu=0,3
c         p1(nu,i)=p(nu,i-1)
c         pres(nu,i)=p1(nu,i)
c        enddo
c       endif
c      enddo

      call getjets(P,jetp,njets,P2)

      if (njets .ne.(maxjets-1)) then
        passcutsdip=.false.
        return
      else
        if (jetcut(P2,njets,debug).eqv..false.) then
         passcutsdip=.false.
         return
        endif
       endif

c     
c     s-channel min & max invariant mass cuts
c     
c      do i=nincoming+1,nexternal-2
c         do k=i+1,nexternal-1
c            if(debug) write (*,*) 's(',i,',',k,')=',dsqrt(Sumdot(p(0,i),p(0,k),+1d0))
c            if(debug) write (*,*) dsqrt(s_min(k,i)),dsqrt(s_max(k,i))
c            if(s_min(k,i).gt.0.or.s_max(k,i).lt.1d5) then
c               tmp=SumDot(p(0,i),p(0,k),+1d0)
c               notgood=(tmp .lt. s_min(k,i).or.tmp .gt. s_max(k,i)) 
c               if (notgood) then
c                  passcutsdip=.false.
c                  return
c               endif
c            endif
c         enddo
c      enddo

      if(.not.fixed_ren_scale) then
         call set_ren_scale(P,scale)
         G = SQRT(4d0*PI*ALPHASPDF(scale))
         call setpara('param_card.dat',.false.)
      endif

      if(.not.fixed_fac_scale) then
         call set_fac_scale(P,q2fact)
      endif


      RETURN
      END


      LOGICAL FUNCTION PASSCUTSDIPQED(P,j)
      IMPLICIT NONE
      include "nexternal.inc"
      include "jets.inc"
      include "run.inc"
      include "coupl.inc"
      DOUBLE PRECISION P(0:3,NEXTERNAL), P1(0:3,NEXTERNAL), P2(0:3,NEXTERNAL), jetp(4,NEXTERNAL)
      integer i,j,nu,njets,k
      logical debug, jetcut,notgood
      double precision pres(0:3,nexternal),pt,rap,r2
      common/res_mom/pres
      double precision etmin(nincoming+1:nexternal),etamax(nincoming+1:nexternal)
      double precision emin(nincoming+1:nexternal)
      double precision r2min(nincoming+1:nexternal,nincoming+1:nexternal)
      double precision s_min(nexternal,nexternal)
      double precision etmax(nincoming+1:nexternal),etamin(nincoming+1:nexternal)
      double precision emax(nincoming+1:nexternal)
      double precision r2max(nincoming+1:nexternal,nincoming+1:nexternal)
      double precision s_max(nexternal,nexternal),sumdot,tmp,alphaspdf
      common/to_cuts/  etmin, emin, etamax, r2min, s_min,
     $     etmax, emax, etamin, r2max, s_max
      real*8 PI
      parameter( PI = 3.14159265358979323846d0 )

      passcutsdipqed=.true.

c      do i=3,5
c       if( pt(p(0,i)).lt.etmin(i)) then
c          passcutsdipqed=.false.
c          return
c       endif
c       if( abs(rap(p(0,i))).gt.etamax(i)) then
c          passcutsdipqed=.false.
c          return
c       endif
c      enddo
c      do i=3,4
c       do k=i+1,5
c         if( i.ne.k .and. p(0,i).gt.0d0 .and.p(0,k).gt.0d0 ) then
c          if (r2(p(0,i),p(0,k)).lt.r2min(k,i)) then
c            passcutsdipqed=.false.
c            return
c          endif
c         endif
c       enddo
c      enddo

c     
c     s-channel min & max invariant mass cuts
c     
c      do i=nincoming+1,nexternal-2
c         do k=i+1,nexternal-1
c            if(debug) write (*,*) 's(',i,',',k,')=',dsqrt(Sumdot(p(0,i),p(0,k),+1d0))
c            if(debug) write (*,*) dsqrt(s_min(k,i)),dsqrt(s_max(k,i))
c            if(s_min(k,i).gt.0.or.s_max(k,i).lt.1d5) then
c               tmp=SumDot(p(0,i),p(0,k),+1d0)
c               notgood=(tmp .lt. s_min(k,i).or.tmp .gt. s_max(k,i)) 
c               if (notgood) then
c                  passcutsdipqed=.false.
c                  return
c               endif
c            endif
c         enddo
c      enddo

      call getjets(P,jetp,njets,P2)

      if (njets .ne.(maxjets-1)) then
        passcutsdipqed=.false.
        return
      else
        if (jetcut(P2,njets,debug).eqv..false.) then
         passcutsdipqed=.false.
         return
        endif
       endif


      if(.not.fixed_ren_scale) then
         call set_ren_scale(P,scale)
         G = SQRT(4d0*PI*ALPHASPDF(scale))
         call setpara('param_card.dat',.false.)
      endif

      if(.not.fixed_fac_scale) then
         call set_fac_scale(P,q2fact)
      endif

      END
