module     dgaad_d28h0l1
   ! file: /.th/pcl340/scratch/gosam/greiner/dg_aad/helicity0d28h0l1.f90
   ! generator: buildfortran.py
   use dgaad_config, only: ki
   use dgaad_util, only: cond
   implicit none
   private
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ function brack_1:
   pure function brack_1(Q,mu2) result(brack)
      use dgaad_model
      use dgaad_kinematics
      use dgaad_color
      use dgaad_abbrevd28h0
      implicit none
      complex(ki), dimension(4), intent(in) :: Q
      complex(ki), intent(in) :: mu2
      complex(ki) :: brack
      complex(ki) :: acc28(46)
      complex(ki) :: Qspk4
      complex(ki) :: Qspk1
      complex(ki) :: Qspvak5k1
      complex(ki) :: Qspvak5k4
      complex(ki) :: Qspe4
      complex(ki) :: Qspvae4k1
      complex(ki) :: Qspe3
      complex(ki) :: Qspvak5e3
      complex(ki) :: Qspk3
      complex(ki) :: Qspk5
      complex(ki) :: QspQ
      complex(ki) :: Qspe2
      complex(ki) :: Qspk2
      Qspk4 = dotproduct(Q,k4)
      Qspk1 = dotproduct(Q,k1)
      Qspvak5k1 = dotproduct(Q,spvak5k1)
      Qspvak5k4 = dotproduct(Q,spvak5k4)
      Qspe4 = dotproduct(Q,e4)
      Qspvae4k1 = dotproduct(Q,spvae4k1)
      Qspe3 = dotproduct(Q,e3)
      Qspvak5e3 = dotproduct(Q,spvak5e3)
      Qspk3 = dotproduct(Q,k3)
      Qspk5 = dotproduct(Q,k5)
      QspQ = dotproduct(Q,Q)
      Qspe2 = dotproduct(Q,e2)
      Qspk2 = dotproduct(Q,k2)
      acc28(1)=abb28(2)
      acc28(2)=abb28(3)
      acc28(3)=abb28(4)
      acc28(4)=abb28(5)
      acc28(5)=abb28(6)
      acc28(6)=abb28(7)
      acc28(7)=abb28(8)
      acc28(8)=abb28(9)
      acc28(9)=abb28(10)
      acc28(10)=abb28(11)
      acc28(11)=abb28(12)
      acc28(12)=abb28(13)
      acc28(13)=abb28(14)
      acc28(14)=abb28(15)
      acc28(15)=abb28(16)
      acc28(16)=abb28(19)
      acc28(17)=abb28(23)
      acc28(18)=abb28(25)
      acc28(19)=abb28(26)
      acc28(20)=abb28(30)
      acc28(21)=abb28(38)
      acc28(22)=abb28(40)
      acc28(23)=abb28(42)
      acc28(24)=abb28(43)
      acc28(25)=abb28(47)
      acc28(26)=abb28(48)
      acc28(27)=abb28(51)
      acc28(28)=abb28(55)
      acc28(29)=abb28(56)
      acc28(30)=abb28(57)
      acc28(31)=abb28(58)
      acc28(32)=abb28(59)
      acc28(33)=abb28(64)
      acc28(34)=abb28(65)
      acc28(35)=abb28(66)
      acc28(36)=abb28(67)
      acc28(37)=abb28(69)
      acc28(38)=Qspk4-Qspk1
      acc28(39)=-acc28(32)*acc28(38)
      acc28(40)=acc28(15)*Qspvak5k1
      acc28(41)=acc28(14)*Qspvak5k4
      acc28(42)=Qspe4*acc28(24)
      acc28(43)=Qspvae4k1*acc28(1)
      acc28(39)=acc28(43)+acc28(42)+acc28(41)+acc28(18)+acc28(40)+acc28(39)
      acc28(39)=Qspe3*acc28(39)
      acc28(40)=-acc28(30)*acc28(38)
      acc28(41)=acc28(5)*Qspvak5e3
      acc28(42)=Qspk3*acc28(35)
      acc28(43)=Qspk5*acc28(29)
      acc28(44)=QspQ*acc28(17)
      acc28(45)=Qspe4*acc28(21)
      acc28(46)=Qspvae4k1*acc28(4)
      acc28(39)=acc28(39)+acc28(46)+acc28(45)+acc28(44)+acc28(43)+acc28(42)+acc&
      &28(13)+acc28(41)+acc28(40)
      acc28(39)=Qspe2*acc28(39)
      acc28(40)=acc28(27)*acc28(38)
      acc28(41)=Qspk2*acc28(37)
      acc28(42)=QspQ*acc28(11)
      acc28(43)=Qspe4*acc28(20)
      acc28(44)=Qspvae4k1*acc28(2)
      acc28(40)=acc28(44)+acc28(43)+acc28(42)+acc28(22)+acc28(41)+acc28(40)
      acc28(40)=Qspe3*acc28(40)
      acc28(41)=Qspk3*acc28(33)
      acc28(42)=Qspk5*acc28(34)
      acc28(43)=QspQ*acc28(19)
      acc28(41)=acc28(41)+acc28(42)+acc28(43)-acc28(31)
      acc28(38)=-acc28(41)*acc28(38)
      acc28(41)=Qspk3*acc28(26)
      acc28(42)=Qspk5*acc28(28)
      acc28(43)=QspQ*acc28(7)
      acc28(41)=acc28(43)+acc28(42)+acc28(16)+acc28(41)
      acc28(41)=Qspe4*acc28(41)
      acc28(42)=Qspk3*acc28(3)
      acc28(43)=Qspk5*acc28(12)
      acc28(44)=QspQ*acc28(10)
      acc28(42)=acc28(44)+acc28(43)+acc28(8)+acc28(42)
      acc28(42)=Qspvae4k1*acc28(42)
      acc28(43)=Qspk2*acc28(36)
      acc28(44)=Qspk3*acc28(23)
      acc28(45)=Qspk5*acc28(25)
      acc28(46)=QspQ*acc28(6)
      brack=acc28(9)+acc28(38)+acc28(39)+acc28(40)+acc28(41)+acc28(42)+acc28(43&
      &)+acc28(44)+acc28(45)+acc28(46)
   end  function brack_1
!---#] function brack_1:
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use dgaad_groups, only: &
!           & sign => diagram28_sign, shift => diagram28_shift
      use dgaad_globalsl1, only: epspow
      use dgaad_kinematics
      use dgaad_abbrevd28h0
      implicit none
      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d28
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      Q(1)  =cmplx(real(-Q_ext(4),  ki_sam),aimag(-Q_ext(4)),  ki)
      Q(2:4)=cmplx(real(-Q_ext(1:3),ki_sam),aimag(-Q_ext(1:3)),ki)
      mu2    = cmplx(real(mu2_ext, ki), aimag(mu2_ext), ki)
      d28 = 0.0_ki
      d28 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d28, ki), aimag(d28), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use dgaad_globalsl1, only: epspow
      use dgaad_kinematics
      use dgaad_abbrevd28h0
      implicit none
      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d28
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      Q(:)  =cmplx(real(-Q_ext(:),  ki_gol), 0.0_ki_gol, ki)
      mu2  = cmplx(real(mu2_ext, ki), 0.0_ki, ki)
      d28 = 0.0_ki
      d28 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d28, ki), aimag(d28), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module dgaad_d28h0l1
