module     dgaad_d59h0l1
   ! file: /.th/pcl340/scratch/gosam/greiner/dg_aad/helicity0d59h0l1.f90
   ! generator: buildfortran.py
   use dgaad_config, only: ki
   use dgaad_util, only: cond
   implicit none
   private
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ function brack_1:
   pure function brack_1(Q,mu2) result(brack)
      use dgaad_model
      use dgaad_kinematics
      use dgaad_color
      use dgaad_abbrevd59h0
      implicit none
      complex(ki), dimension(4), intent(in) :: Q
      complex(ki), intent(in) :: mu2
      complex(ki) :: brack
      complex(ki) :: acc59(39)
      complex(ki) :: Qspvak5k1
      complex(ki) :: Qspvak2k1
      complex(ki) :: Qspe4
      complex(ki) :: Qspvak4k1
      complex(ki) :: Qspvak2k3
      complex(ki) :: Qspvak2k4
      complex(ki) :: Qspvak5k3
      complex(ki) :: Qspvak5k4
      complex(ki) :: Qspvak3k1
      complex(ki) :: Qspvae4k1
      complex(ki) :: Qspvak2e4
      complex(ki) :: Qspvak5e4
      complex(ki) :: Qspe3
      complex(ki) :: Qspvae3k1
      complex(ki) :: QspQ
      complex(ki) :: Qspk3
      Qspvak5k1 = dotproduct(Q,spvak5k1)
      Qspvak2k1 = dotproduct(Q,spvak2k1)
      Qspe4 = dotproduct(Q,e4)
      Qspvak4k1 = dotproduct(Q,spvak4k1)
      Qspvak2k3 = dotproduct(Q,spvak2k3)
      Qspvak2k4 = dotproduct(Q,spvak2k4)
      Qspvak5k3 = dotproduct(Q,spvak5k3)
      Qspvak5k4 = dotproduct(Q,spvak5k4)
      Qspvak3k1 = dotproduct(Q,spvak3k1)
      Qspvae4k1 = dotproduct(Q,spvae4k1)
      Qspvak2e4 = dotproduct(Q,spvak2e4)
      Qspvak5e4 = dotproduct(Q,spvak5e4)
      Qspe3 = dotproduct(Q,e3)
      Qspvae3k1 = dotproduct(Q,spvae3k1)
      QspQ = dotproduct(Q,Q)
      Qspk3 = dotproduct(Q,k3)
      acc59(1)=abb59(3)
      acc59(2)=abb59(4)
      acc59(3)=abb59(5)
      acc59(4)=abb59(6)
      acc59(5)=abb59(7)
      acc59(6)=abb59(8)
      acc59(7)=abb59(9)
      acc59(8)=abb59(10)
      acc59(9)=abb59(11)
      acc59(10)=abb59(12)
      acc59(11)=abb59(13)
      acc59(12)=abb59(14)
      acc59(13)=abb59(15)
      acc59(14)=abb59(16)
      acc59(15)=abb59(17)
      acc59(16)=abb59(18)
      acc59(17)=abb59(19)
      acc59(18)=abb59(20)
      acc59(19)=abb59(21)
      acc59(20)=abb59(22)
      acc59(21)=abb59(23)
      acc59(22)=abb59(24)
      acc59(23)=abb59(25)
      acc59(24)=abb59(26)
      acc59(25)=abb59(27)
      acc59(26)=abb59(29)
      acc59(27)=abb59(30)
      acc59(28)=abb59(31)
      acc59(29)=abb59(32)
      acc59(30)=acc59(3)*Qspvak5k1
      acc59(31)=acc59(1)*Qspvak2k1
      acc59(30)=acc59(30)+acc59(31)
      acc59(30)=Qspe4*acc59(30)
      acc59(31)=acc59(29)*Qspvak4k1
      acc59(32)=Qspvak2k3*acc59(25)
      acc59(33)=Qspvak2k4*acc59(20)
      acc59(34)=Qspvak5k3*acc59(28)
      acc59(35)=Qspvak5k4*acc59(26)
      acc59(36)=Qspvak3k1*acc59(18)
      acc59(37)=Qspvae4k1*acc59(14)
      acc59(38)=Qspvak2e4*acc59(8)
      acc59(39)=Qspvak5e4*acc59(9)
      acc59(30)=acc59(30)+acc59(39)+acc59(38)+acc59(37)+acc59(36)+acc59(35)+acc&
      &59(34)+acc59(33)+acc59(31)+acc59(32)
      acc59(30)=Qspe3*acc59(30)
      acc59(31)=Qspvak2k3*acc59(23)
      acc59(32)=Qspvak5k3*acc59(27)
      acc59(33)=Qspvak3k1*acc59(6)
      acc59(34)=Qspvae3k1*acc59(15)
      acc59(35)=QspQ*acc59(7)
      acc59(31)=acc59(35)+acc59(34)+acc59(33)+acc59(31)+acc59(32)
      acc59(31)=Qspe4*acc59(31)
      acc59(32)=Qspvae4k1*acc59(4)
      acc59(33)=Qspvak2e4*acc59(10)
      acc59(34)=Qspvak5e4*acc59(13)
      acc59(35)=Qspvae3k1*acc59(21)
      acc59(32)=acc59(35)+acc59(34)+acc59(33)+acc59(5)+acc59(32)
      acc59(32)=QspQ*acc59(32)
      acc59(33)=Qspvae4k1*acc59(16)
      acc59(34)=Qspvak2e4*acc59(11)
      acc59(35)=Qspvak5e4*acc59(12)
      acc59(33)=acc59(35)+acc59(33)+acc59(34)
      acc59(33)=Qspk3*acc59(33)
      acc59(34)=Qspvak2k4*acc59(17)
      acc59(35)=Qspvak5k4*acc59(24)
      acc59(36)=Qspvak3k1*acc59(2)
      acc59(37)=Qspk3*acc59(22)
      acc59(37)=acc59(19)+acc59(37)
      acc59(37)=Qspvae3k1*acc59(37)
      brack=acc59(30)+acc59(31)+acc59(32)+acc59(33)+acc59(34)+acc59(35)+acc59(3&
      &6)+acc59(37)
   end  function brack_1
!---#] function brack_1:
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use dgaad_groups, only: &
!           & sign => diagram59_sign, shift => diagram59_shift
      use dgaad_globalsl1, only: epspow
      use dgaad_kinematics
      use dgaad_abbrevd59h0
      implicit none
      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d59
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(0:3) :: qshift
      qshift = k3+k5+k4
      Q(1)  =cmplx(real(+Q_ext(4)  -qshift(0),  ki_sam),aimag(+Q_ext(4)),  ki)
      Q(2:4)=cmplx(real(+Q_ext(1:3)-qshift(1:3),ki_sam),aimag(+Q_ext(1:3)),ki)
      mu2    = cmplx(real(mu2_ext, ki), aimag(mu2_ext), ki)
      d59 = 0.0_ki
      d59 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d59, ki), aimag(d59), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use dgaad_globalsl1, only: epspow
      use dgaad_kinematics
      use dgaad_abbrevd59h0
      implicit none
      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d59
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(4) :: qshift
      qshift = k3+k5+k4
      Q(:)  =cmplx(real(+Q_ext(:)  -qshift(:),  ki_gol), 0.0_ki_gol, ki)
      mu2  = cmplx(real(mu2_ext, ki), 0.0_ki, ki)
      d59 = 0.0_ki
      d59 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d59, ki), aimag(d59), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module dgaad_d59h0l1
