module     dgaad_d60h0l1
   ! file: /.th/pcl340/scratch/gosam/greiner/dg_aad/helicity0d60h0l1.f90
   ! generator: buildfortran.py
   use dgaad_config, only: ki
   use dgaad_util, only: cond
   implicit none
   private
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ function brack_1:
   pure function brack_1(Q,mu2) result(brack)
      use dgaad_model
      use dgaad_kinematics
      use dgaad_color
      use dgaad_abbrevd60h0
      implicit none
      complex(ki), dimension(4), intent(in) :: Q
      complex(ki), intent(in) :: mu2
      complex(ki) :: brack
      complex(ki) :: acc60(39)
      complex(ki) :: Qspvak5k1
      complex(ki) :: Qspvak2k1
      complex(ki) :: Qspe3
      complex(ki) :: Qspvak3k1
      complex(ki) :: Qspvak2k3
      complex(ki) :: Qspvak2k4
      complex(ki) :: Qspvak5k3
      complex(ki) :: Qspvak5k4
      complex(ki) :: Qspvak4k1
      complex(ki) :: Qspvae3k1
      complex(ki) :: Qspvak2e3
      complex(ki) :: Qspvak5e3
      complex(ki) :: Qspe4
      complex(ki) :: Qspvae4k1
      complex(ki) :: QspQ
      complex(ki) :: Qspk4
      Qspvak5k1 = dotproduct(Q,spvak5k1)
      Qspvak2k1 = dotproduct(Q,spvak2k1)
      Qspe3 = dotproduct(Q,e3)
      Qspvak3k1 = dotproduct(Q,spvak3k1)
      Qspvak2k3 = dotproduct(Q,spvak2k3)
      Qspvak2k4 = dotproduct(Q,spvak2k4)
      Qspvak5k3 = dotproduct(Q,spvak5k3)
      Qspvak5k4 = dotproduct(Q,spvak5k4)
      Qspvak4k1 = dotproduct(Q,spvak4k1)
      Qspvae3k1 = dotproduct(Q,spvae3k1)
      Qspvak2e3 = dotproduct(Q,spvak2e3)
      Qspvak5e3 = dotproduct(Q,spvak5e3)
      Qspe4 = dotproduct(Q,e4)
      Qspvae4k1 = dotproduct(Q,spvae4k1)
      QspQ = dotproduct(Q,Q)
      Qspk4 = dotproduct(Q,k4)
      acc60(1)=abb60(3)
      acc60(2)=abb60(4)
      acc60(3)=abb60(5)
      acc60(4)=abb60(6)
      acc60(5)=abb60(7)
      acc60(6)=abb60(8)
      acc60(7)=abb60(9)
      acc60(8)=abb60(10)
      acc60(9)=abb60(11)
      acc60(10)=abb60(12)
      acc60(11)=abb60(13)
      acc60(12)=abb60(14)
      acc60(13)=abb60(15)
      acc60(14)=abb60(16)
      acc60(15)=abb60(17)
      acc60(16)=abb60(18)
      acc60(17)=abb60(19)
      acc60(18)=abb60(20)
      acc60(19)=abb60(21)
      acc60(20)=abb60(22)
      acc60(21)=abb60(23)
      acc60(22)=abb60(24)
      acc60(23)=abb60(25)
      acc60(24)=abb60(26)
      acc60(25)=abb60(27)
      acc60(26)=abb60(28)
      acc60(27)=abb60(29)
      acc60(28)=abb60(30)
      acc60(29)=abb60(31)
      acc60(30)=acc60(3)*Qspvak5k1
      acc60(31)=acc60(1)*Qspvak2k1
      acc60(30)=acc60(30)+acc60(31)
      acc60(30)=Qspe3*acc60(30)
      acc60(31)=acc60(19)*Qspvak3k1
      acc60(32)=Qspvak2k3*acc60(23)
      acc60(33)=Qspvak2k4*acc60(24)
      acc60(34)=Qspvak5k3*acc60(29)
      acc60(35)=Qspvak5k4*acc60(25)
      acc60(36)=Qspvak4k1*acc60(16)
      acc60(37)=Qspvae3k1*acc60(14)
      acc60(38)=Qspvak2e3*acc60(8)
      acc60(39)=Qspvak5e3*acc60(9)
      acc60(30)=acc60(30)+acc60(39)+acc60(38)+acc60(37)+acc60(36)+acc60(35)+acc&
      &60(34)+acc60(33)+acc60(31)+acc60(32)
      acc60(30)=Qspe4*acc60(30)
      acc60(31)=Qspvak2k4*acc60(27)
      acc60(32)=Qspvak5k4*acc60(28)
      acc60(33)=Qspvak4k1*acc60(6)
      acc60(34)=Qspvae4k1*acc60(18)
      acc60(35)=QspQ*acc60(7)
      acc60(31)=acc60(35)+acc60(34)+acc60(33)+acc60(31)+acc60(32)
      acc60(31)=Qspe3*acc60(31)
      acc60(32)=Qspvae3k1*acc60(4)
      acc60(33)=Qspvak2e3*acc60(10)
      acc60(34)=Qspvak5e3*acc60(13)
      acc60(35)=Qspvae4k1*acc60(20)
      acc60(32)=acc60(35)+acc60(34)+acc60(33)+acc60(5)+acc60(32)
      acc60(32)=QspQ*acc60(32)
      acc60(33)=Qspvae3k1*acc60(22)
      acc60(34)=Qspvak2e3*acc60(11)
      acc60(35)=Qspvak5e3*acc60(12)
      acc60(33)=acc60(35)+acc60(33)+acc60(34)
      acc60(33)=Qspk4*acc60(33)
      acc60(34)=Qspvak2k3*acc60(15)
      acc60(35)=Qspvak5k3*acc60(26)
      acc60(36)=Qspvak4k1*acc60(2)
      acc60(37)=Qspk4*acc60(21)
      acc60(37)=acc60(17)+acc60(37)
      acc60(37)=Qspvae4k1*acc60(37)
      brack=acc60(30)+acc60(31)+acc60(32)+acc60(33)+acc60(34)+acc60(35)+acc60(3&
      &6)+acc60(37)
   end  function brack_1
!---#] function brack_1:
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use dgaad_groups, only: &
!           & sign => diagram60_sign, shift => diagram60_shift
      use dgaad_globalsl1, only: epspow
      use dgaad_kinematics
      use dgaad_abbrevd60h0
      implicit none
      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d60
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(0:3) :: qshift
      qshift = k3+k4
      Q(1)  =cmplx(real(+Q_ext(4)  -qshift(0),  ki_sam),aimag(+Q_ext(4)),  ki)
      Q(2:4)=cmplx(real(+Q_ext(1:3)-qshift(1:3),ki_sam),aimag(+Q_ext(1:3)),ki)
      mu2    = cmplx(real(mu2_ext, ki), aimag(mu2_ext), ki)
      d60 = 0.0_ki
      d60 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d60, ki), aimag(d60), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use dgaad_globalsl1, only: epspow
      use dgaad_kinematics
      use dgaad_abbrevd60h0
      implicit none
      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d60
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(4) :: qshift
      qshift = k3+k4
      Q(:)  =cmplx(real(+Q_ext(:)  -qshift(:),  ki_gol), 0.0_ki_gol, ki)
      mu2  = cmplx(real(mu2_ext, ki), 0.0_ki, ki)
      d60 = 0.0_ki
      d60 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d60, ki), aimag(d60), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module dgaad_d60h0l1
