module     dgaad_d62h0l1
   ! file: /.th/pcl340/scratch/gosam/greiner/dg_aad/helicity0d62h0l1.f90
   ! generator: buildfortran.py
   use dgaad_config, only: ki
   use dgaad_util, only: cond
   implicit none
   private
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ function brack_1:
   pure function brack_1(Q,mu2) result(brack)
      use dgaad_model
      use dgaad_kinematics
      use dgaad_color
      use dgaad_abbrevd62h0
      implicit none
      complex(ki), dimension(4), intent(in) :: Q
      complex(ki), intent(in) :: mu2
      complex(ki) :: brack
      complex(ki) :: acc62(41)
      complex(ki) :: Qspvak2k1
      complex(ki) :: Qspvak3e4
      complex(ki) :: Qspvak5k2
      complex(ki) :: Qspvak5e4
      complex(ki) :: Qspvak3k2
      complex(ki) :: Qspvae4k1
      complex(ki) :: Qspvak3k4
      complex(ki) :: Qspvak5k4
      complex(ki) :: Qspvak4k1
      complex(ki) :: Qspe2
      complex(ki) :: Qspvak5k1
      complex(ki) :: Qspvak3k1
      complex(ki) :: Qspvae2k1
      complex(ki) :: Qspe4
      complex(ki) :: QspQ
      complex(ki) :: Qspk2
      Qspvak2k1 = dotproduct(Q,spvak2k1)
      Qspvak3e4 = dotproduct(Q,spvak3e4)
      Qspvak5k2 = dotproduct(Q,spvak5k2)
      Qspvak5e4 = dotproduct(Q,spvak5e4)
      Qspvak3k2 = dotproduct(Q,spvak3k2)
      Qspvae4k1 = dotproduct(Q,spvae4k1)
      Qspvak3k4 = dotproduct(Q,spvak3k4)
      Qspvak5k4 = dotproduct(Q,spvak5k4)
      Qspvak4k1 = dotproduct(Q,spvak4k1)
      Qspe2 = dotproduct(Q,e2)
      Qspvak5k1 = dotproduct(Q,spvak5k1)
      Qspvak3k1 = dotproduct(Q,spvak3k1)
      Qspvae2k1 = dotproduct(Q,spvae2k1)
      Qspe4 = dotproduct(Q,e4)
      QspQ = dotproduct(Q,Q)
      Qspk2 = dotproduct(Q,k2)
      acc62(1)=abb62(3)
      acc62(2)=abb62(4)
      acc62(3)=abb62(5)
      acc62(4)=abb62(6)
      acc62(5)=abb62(7)
      acc62(6)=abb62(8)
      acc62(7)=abb62(9)
      acc62(8)=abb62(10)
      acc62(9)=abb62(11)
      acc62(10)=abb62(12)
      acc62(11)=abb62(13)
      acc62(12)=abb62(14)
      acc62(13)=abb62(15)
      acc62(14)=abb62(16)
      acc62(15)=abb62(17)
      acc62(16)=abb62(18)
      acc62(17)=abb62(19)
      acc62(18)=abb62(20)
      acc62(19)=abb62(21)
      acc62(20)=abb62(23)
      acc62(21)=abb62(25)
      acc62(22)=abb62(26)
      acc62(23)=abb62(28)
      acc62(24)=abb62(29)
      acc62(25)=abb62(30)
      acc62(26)=abb62(31)
      acc62(27)=abb62(32)
      acc62(28)=abb62(33)
      acc62(29)=abb62(35)
      acc62(30)=abb62(36)
      acc62(31)=abb62(38)
      acc62(32)=acc62(8)*Qspvak2k1
      acc62(33)=acc62(10)*Qspvak3e4
      acc62(34)=acc62(11)*Qspvak5k2
      acc62(35)=acc62(12)*Qspvak5e4
      acc62(36)=acc62(16)*Qspvak3k2
      acc62(37)=acc62(21)*Qspvae4k1
      acc62(38)=acc62(29)*Qspvak3k4
      acc62(39)=acc62(30)*Qspvak5k4
      acc62(40)=Qspvak4k1*acc62(23)
      acc62(32)=acc62(40)+acc62(39)+acc62(38)+acc62(37)+acc62(36)+acc62(35)+acc&
      &62(34)+acc62(33)+acc62(32)
      acc62(32)=Qspe2*acc62(32)
      acc62(33)=Qspvak5k1*acc62(2)
      acc62(34)=Qspvak3k1*acc62(3)
      acc62(33)=acc62(34)+acc62(33)
      acc62(33)=acc62(33)*Qspe2
      acc62(34)=acc62(7)*Qspvak2k1
      acc62(35)=acc62(13)*Qspvak5k2
      acc62(36)=acc62(17)*Qspvak3k2
      acc62(37)=acc62(20)*Qspvae2k1
      acc62(33)=acc62(33)+acc62(37)+acc62(36)+acc62(35)+acc62(34)
      acc62(33)=Qspe4*acc62(33)
      acc62(34)=acc62(5)*Qspvae4k1
      acc62(35)=acc62(9)*Qspe4
      acc62(36)=acc62(14)*Qspvak5e4
      acc62(37)=acc62(18)*Qspvak3e4
      acc62(38)=acc62(24)*Qspvae2k1
      acc62(34)=acc62(38)+acc62(37)+acc62(36)+acc62(35)+acc62(34)+acc62(1)
      acc62(34)=QspQ*acc62(34)
      acc62(35)=acc62(15)*Qspvak5e4
      acc62(36)=acc62(19)*Qspvak3e4
      acc62(37)=acc62(22)*Qspvae4k1
      acc62(38)=acc62(25)*Qspvae2k1
      acc62(35)=acc62(38)+acc62(37)+acc62(36)+acc62(35)
      acc62(35)=Qspk2*acc62(35)
      acc62(36)=acc62(4)*Qspvak2k1
      acc62(37)=acc62(6)*Qspvae2k1
      acc62(38)=acc62(26)*Qspvak3k2
      acc62(39)=acc62(27)*Qspvak5k2
      acc62(40)=acc62(28)*Qspvak5k4
      acc62(41)=acc62(31)*Qspvak3k4
      brack=acc62(32)+acc62(33)+acc62(34)+acc62(35)+acc62(36)+acc62(37)+acc62(3&
      &8)+acc62(39)+acc62(40)+acc62(41)
   end  function brack_1
!---#] function brack_1:
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use dgaad_groups, only: &
!           & sign => diagram62_sign, shift => diagram62_shift
      use dgaad_globalsl1, only: epspow
      use dgaad_kinematics
      use dgaad_abbrevd62h0
      implicit none
      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d62
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(0:3) :: qshift
      qshift = -k2
      Q(1)  =cmplx(real(-Q_ext(4)  -qshift(0),  ki_sam),aimag(-Q_ext(4)),  ki)
      Q(2:4)=cmplx(real(-Q_ext(1:3)-qshift(1:3),ki_sam),aimag(-Q_ext(1:3)),ki)
      mu2    = cmplx(real(mu2_ext, ki), aimag(mu2_ext), ki)
      d62 = 0.0_ki
      d62 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d62, ki), aimag(d62), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use dgaad_globalsl1, only: epspow
      use dgaad_kinematics
      use dgaad_abbrevd62h0
      implicit none
      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d62
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(4) :: qshift
      qshift = -k2
      Q(:)  =cmplx(real(-Q_ext(:)  -qshift(:),  ki_gol), 0.0_ki_gol, ki)
      mu2  = cmplx(real(mu2_ext, ki), 0.0_ki, ki)
      d62 = 0.0_ki
      d62 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d62, ki), aimag(d62), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module dgaad_d62h0l1
