module     dgaad_d25h8l1
   ! file: /.th/pcl340/scratch/gosam/greiner/dg_aad/helicity8d25h8l1.f90
   ! generator: buildfortran.py
   use dgaad_config, only: ki
   use dgaad_util, only: cond
   implicit none
   private
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ function brack_1:
   pure function brack_1(Q,mu2) result(brack)
      use dgaad_model
      use dgaad_kinematics
      use dgaad_color
      use dgaad_abbrevd25h8
      implicit none
      complex(ki), dimension(4), intent(in) :: Q
      complex(ki), intent(in) :: mu2
      complex(ki) :: brack
      complex(ki) :: acc25(46)
      complex(ki) :: Qspk3
      complex(ki) :: Qspk1
      complex(ki) :: Qspvak1k5
      complex(ki) :: Qspvak3k5
      complex(ki) :: Qspe3
      complex(ki) :: Qspvak1e3
      complex(ki) :: Qspe4
      complex(ki) :: Qspvae4k5
      complex(ki) :: Qspk4
      complex(ki) :: Qspk5
      complex(ki) :: QspQ
      complex(ki) :: Qspe2
      complex(ki) :: Qspk2
      Qspk3 = dotproduct(Q,k3)
      Qspk1 = dotproduct(Q,k1)
      Qspvak1k5 = dotproduct(Q,spvak1k5)
      Qspvak3k5 = dotproduct(Q,spvak3k5)
      Qspe3 = dotproduct(Q,e3)
      Qspvak1e3 = dotproduct(Q,spvak1e3)
      Qspe4 = dotproduct(Q,e4)
      Qspvae4k5 = dotproduct(Q,spvae4k5)
      Qspk4 = dotproduct(Q,k4)
      Qspk5 = dotproduct(Q,k5)
      QspQ = dotproduct(Q,Q)
      Qspe2 = dotproduct(Q,e2)
      Qspk2 = dotproduct(Q,k2)
      acc25(1)=abb25(2)
      acc25(2)=abb25(3)
      acc25(3)=abb25(4)
      acc25(4)=abb25(5)
      acc25(5)=abb25(6)
      acc25(6)=abb25(7)
      acc25(7)=abb25(8)
      acc25(8)=abb25(9)
      acc25(9)=abb25(10)
      acc25(10)=abb25(11)
      acc25(11)=abb25(12)
      acc25(12)=abb25(13)
      acc25(13)=abb25(14)
      acc25(14)=abb25(15)
      acc25(15)=abb25(16)
      acc25(16)=abb25(17)
      acc25(17)=abb25(18)
      acc25(18)=abb25(19)
      acc25(19)=abb25(20)
      acc25(20)=abb25(30)
      acc25(21)=abb25(31)
      acc25(22)=abb25(36)
      acc25(23)=abb25(40)
      acc25(24)=abb25(46)
      acc25(25)=abb25(48)
      acc25(26)=abb25(51)
      acc25(27)=abb25(54)
      acc25(28)=abb25(55)
      acc25(29)=abb25(56)
      acc25(30)=abb25(57)
      acc25(31)=abb25(58)
      acc25(32)=abb25(59)
      acc25(33)=abb25(60)
      acc25(34)=abb25(65)
      acc25(35)=abb25(66)
      acc25(36)=abb25(67)
      acc25(37)=abb25(69)
      acc25(38)=Qspk3-Qspk1
      acc25(39)=-acc25(33)*acc25(38)
      acc25(40)=acc25(16)*Qspvak1k5
      acc25(41)=acc25(15)*Qspvak3k5
      acc25(42)=Qspe3*acc25(24)
      acc25(43)=Qspvak1e3*acc25(1)
      acc25(39)=acc25(43)+acc25(42)+acc25(41)+acc25(18)+acc25(40)+acc25(39)
      acc25(39)=Qspe4*acc25(39)
      acc25(40)=acc25(31)*acc25(38)
      acc25(41)=acc25(5)*Qspvae4k5
      acc25(42)=Qspk4*acc25(30)
      acc25(43)=Qspk5*acc25(29)
      acc25(44)=QspQ*acc25(11)
      acc25(45)=Qspe3*acc25(25)
      acc25(46)=Qspvak1e3*acc25(4)
      acc25(39)=acc25(39)+acc25(46)+acc25(45)+acc25(44)+acc25(43)+acc25(42)+acc&
      &25(13)+acc25(41)+acc25(40)
      acc25(39)=Qspe2*acc25(39)
      acc25(40)=acc25(26)*acc25(38)
      acc25(41)=Qspk2*acc25(37)
      acc25(42)=QspQ*acc25(7)
      acc25(43)=Qspe3*acc25(23)
      acc25(44)=Qspvak1e3*acc25(2)
      acc25(40)=acc25(44)+acc25(43)+acc25(42)+acc25(17)+acc25(41)+acc25(40)
      acc25(40)=Qspe4*acc25(40)
      acc25(41)=Qspk4*acc25(34)
      acc25(42)=Qspk5*acc25(35)
      acc25(43)=QspQ*acc25(19)
      acc25(41)=acc25(41)+acc25(42)+acc25(43)-acc25(32)
      acc25(38)=acc25(41)*acc25(38)
      acc25(41)=Qspk4*acc25(27)
      acc25(42)=Qspk5*acc25(28)
      acc25(43)=QspQ*acc25(10)
      acc25(41)=acc25(43)+acc25(42)+acc25(20)+acc25(41)
      acc25(41)=Qspe3*acc25(41)
      acc25(42)=Qspk4*acc25(3)
      acc25(43)=Qspk5*acc25(14)
      acc25(44)=QspQ*acc25(12)
      acc25(42)=acc25(44)+acc25(43)+acc25(8)+acc25(42)
      acc25(42)=Qspvak1e3*acc25(42)
      acc25(43)=Qspk2*acc25(36)
      acc25(44)=Qspk4*acc25(21)
      acc25(45)=Qspk5*acc25(22)
      acc25(46)=QspQ*acc25(6)
      brack=acc25(9)+acc25(38)+acc25(39)+acc25(40)+acc25(41)+acc25(42)+acc25(43&
      &)+acc25(44)+acc25(45)+acc25(46)
   end  function brack_1
!---#] function brack_1:
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use dgaad_groups, only: &
!           & sign => diagram25_sign, shift => diagram25_shift
      use dgaad_globalsl1, only: epspow
      use dgaad_kinematics
      use dgaad_abbrevd25h8
      implicit none
      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d25
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      Q(1)  =cmplx(real(-Q_ext(4),  ki_sam),aimag(-Q_ext(4)),  ki)
      Q(2:4)=cmplx(real(-Q_ext(1:3),ki_sam),aimag(-Q_ext(1:3)),ki)
      mu2    = cmplx(real(mu2_ext, ki), aimag(mu2_ext), ki)
      d25 = 0.0_ki
      d25 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d25, ki), aimag(d25), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use dgaad_globalsl1, only: epspow
      use dgaad_kinematics
      use dgaad_abbrevd25h8
      implicit none
      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d25
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      Q(:)  =cmplx(real(-Q_ext(:),  ki_gol), 0.0_ki_gol, ki)
      mu2  = cmplx(real(mu2_ext, ki), 0.0_ki, ki)
      d25 = 0.0_ki
      d25 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d25, ki), aimag(d25), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module dgaad_d25h8l1
