module     dgaad_d63h8l1
   ! file: /.th/pcl340/scratch/gosam/greiner/dg_aad/helicity8d63h8l1.f90
   ! generator: buildfortran.py
   use dgaad_config, only: ki
   use dgaad_util, only: cond
   implicit none
   private
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ function brack_1:
   pure function brack_1(Q,mu2) result(brack)
      use dgaad_model
      use dgaad_kinematics
      use dgaad_color
      use dgaad_abbrevd63h8
      implicit none
      complex(ki), dimension(4), intent(in) :: Q
      complex(ki), intent(in) :: mu2
      complex(ki) :: brack
      complex(ki) :: acc63(41)
      complex(ki) :: Qspvak1k4
      complex(ki) :: Qspvae2k3
      complex(ki) :: Qspvak4k5
      complex(ki) :: Qspvae2k5
      complex(ki) :: Qspvak4k3
      complex(ki) :: Qspvak1e2
      complex(ki) :: Qspvak2k3
      complex(ki) :: Qspvak2k5
      complex(ki) :: Qspvak1k2
      complex(ki) :: Qspe4
      complex(ki) :: Qspvak1k5
      complex(ki) :: Qspvak1k3
      complex(ki) :: Qspvak1e4
      complex(ki) :: Qspe2
      complex(ki) :: QspQ
      complex(ki) :: Qspk4
      Qspvak1k4 = dotproduct(Q,spvak1k4)
      Qspvae2k3 = dotproduct(Q,spvae2k3)
      Qspvak4k5 = dotproduct(Q,spvak4k5)
      Qspvae2k5 = dotproduct(Q,spvae2k5)
      Qspvak4k3 = dotproduct(Q,spvak4k3)
      Qspvak1e2 = dotproduct(Q,spvak1e2)
      Qspvak2k3 = dotproduct(Q,spvak2k3)
      Qspvak2k5 = dotproduct(Q,spvak2k5)
      Qspvak1k2 = dotproduct(Q,spvak1k2)
      Qspe4 = dotproduct(Q,e4)
      Qspvak1k5 = dotproduct(Q,spvak1k5)
      Qspvak1k3 = dotproduct(Q,spvak1k3)
      Qspvak1e4 = dotproduct(Q,spvak1e4)
      Qspe2 = dotproduct(Q,e2)
      QspQ = dotproduct(Q,Q)
      Qspk4 = dotproduct(Q,k4)
      acc63(1)=abb63(3)
      acc63(2)=abb63(4)
      acc63(3)=abb63(5)
      acc63(4)=abb63(6)
      acc63(5)=abb63(7)
      acc63(6)=abb63(8)
      acc63(7)=abb63(9)
      acc63(8)=abb63(10)
      acc63(9)=abb63(11)
      acc63(10)=abb63(12)
      acc63(11)=abb63(13)
      acc63(12)=abb63(14)
      acc63(13)=abb63(15)
      acc63(14)=abb63(16)
      acc63(15)=abb63(17)
      acc63(16)=abb63(18)
      acc63(17)=abb63(19)
      acc63(18)=abb63(20)
      acc63(19)=abb63(21)
      acc63(20)=abb63(22)
      acc63(21)=abb63(23)
      acc63(22)=abb63(26)
      acc63(23)=abb63(28)
      acc63(24)=abb63(29)
      acc63(25)=abb63(30)
      acc63(26)=abb63(31)
      acc63(27)=abb63(32)
      acc63(28)=abb63(33)
      acc63(29)=abb63(34)
      acc63(30)=abb63(35)
      acc63(31)=abb63(36)
      acc63(32)=acc63(7)*Qspvak1k4
      acc63(33)=acc63(10)*Qspvae2k3
      acc63(34)=acc63(11)*Qspvak4k5
      acc63(35)=acc63(12)*Qspvae2k5
      acc63(36)=acc63(16)*Qspvak4k3
      acc63(37)=acc63(21)*Qspvak1e2
      acc63(38)=acc63(29)*Qspvak2k3
      acc63(39)=acc63(30)*Qspvak2k5
      acc63(40)=Qspvak1k2*acc63(20)
      acc63(32)=acc63(40)+acc63(39)+acc63(38)+acc63(37)+acc63(36)+acc63(35)+acc&
      &63(34)+acc63(33)+acc63(32)
      acc63(32)=Qspe4*acc63(32)
      acc63(33)=Qspvak1k5*acc63(2)
      acc63(34)=Qspvak1k3*acc63(3)
      acc63(33)=acc63(34)+acc63(33)
      acc63(33)=acc63(33)*Qspe4
      acc63(34)=acc63(8)*Qspvak1k4
      acc63(35)=acc63(13)*Qspvak4k5
      acc63(36)=acc63(17)*Qspvak4k3
      acc63(37)=acc63(22)*Qspvak1e4
      acc63(33)=acc63(33)+acc63(37)+acc63(36)+acc63(35)+acc63(34)
      acc63(33)=Qspe2*acc63(33)
      acc63(34)=acc63(5)*Qspvak1e2
      acc63(35)=acc63(9)*Qspe2
      acc63(36)=acc63(14)*Qspvae2k5
      acc63(37)=acc63(18)*Qspvae2k3
      acc63(38)=acc63(23)*Qspvak1e4
      acc63(34)=acc63(38)+acc63(37)+acc63(36)+acc63(35)+acc63(34)+acc63(1)
      acc63(34)=QspQ*acc63(34)
      acc63(35)=acc63(15)*Qspvae2k5
      acc63(36)=acc63(19)*Qspvae2k3
      acc63(37)=acc63(24)*Qspvak1e4
      acc63(38)=acc63(25)*Qspvak1e2
      acc63(35)=acc63(38)+acc63(37)+acc63(36)+acc63(35)
      acc63(35)=Qspk4*acc63(35)
      acc63(36)=acc63(4)*Qspvak1k4
      acc63(37)=acc63(6)*Qspvak1e4
      acc63(38)=acc63(26)*Qspvak2k3
      acc63(39)=acc63(27)*Qspvak2k5
      acc63(40)=acc63(28)*Qspvak4k5
      acc63(41)=acc63(31)*Qspvak4k3
      brack=acc63(32)+acc63(33)+acc63(34)+acc63(35)+acc63(36)+acc63(37)+acc63(3&
      &8)+acc63(39)+acc63(40)+acc63(41)
   end  function brack_1
!---#] function brack_1:
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use dgaad_groups, only: &
!           & sign => diagram63_sign, shift => diagram63_shift
      use dgaad_globalsl1, only: epspow
      use dgaad_kinematics
      use dgaad_abbrevd63h8
      implicit none
      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d63
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(0:3) :: qshift
      qshift = -k2+k4
      Q(1)  =cmplx(real(-Q_ext(4)  -qshift(0),  ki_sam),aimag(-Q_ext(4)),  ki)
      Q(2:4)=cmplx(real(-Q_ext(1:3)-qshift(1:3),ki_sam),aimag(-Q_ext(1:3)),ki)
      mu2    = cmplx(real(mu2_ext, ki), aimag(mu2_ext), ki)
      d63 = 0.0_ki
      d63 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d63, ki), aimag(d63), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use dgaad_globalsl1, only: epspow
      use dgaad_kinematics
      use dgaad_abbrevd63h8
      implicit none
      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d63
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(4) :: qshift
      qshift = -k2+k4
      Q(:)  =cmplx(real(-Q_ext(:)  -qshift(:),  ki_gol), 0.0_ki_gol, ki)
      mu2  = cmplx(real(mu2_ext, ki), 0.0_ki, ki)
      d63 = 0.0_ki
      d63 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d63, ki), aimag(d63), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module dgaad_d63h8l1
