module     ugaau_d154h0l1
   ! file: /.th/pcl340/scratch/gosam/greiner/ug_aau/helicity0d154h0l1.f90
   ! generator: buildfortran.py
   use ugaau_config, only: ki
   use ugaau_util, only: cond
   implicit none
   private
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ function brack_1:
   pure function brack_1(Q,mu2) result(brack)
      use ugaau_model
      use ugaau_kinematics
      use ugaau_color
      use ugaau_abbrevd154h0
      implicit none
      complex(ki), dimension(4), intent(in) :: Q
      complex(ki), intent(in) :: mu2
      complex(ki) :: brack
      complex(ki) :: acc154(88)
      complex(ki) :: Qspk2
      complex(ki) :: Qspk5
      complex(ki) :: Qspvak5k2
      complex(ki) :: Qspvak4k1
      complex(ki) :: Qspvak5k1
      complex(ki) :: Qspvae3k1
      complex(ki) :: Qspvak5e3
      complex(ki) :: Qspvak2k1
      complex(ki) :: Qspk1
      complex(ki) :: QspQ
      complex(ki) :: Qspe3
      complex(ki) :: Qspe4
      complex(ki) :: Qspvak5k4
      complex(ki) :: Qspvae4k1
      complex(ki) :: Qspk4
      complex(ki) :: Qspe2
      complex(ki) :: Qspvae2k1
      Qspk2 = dotproduct(Q,k2)
      Qspk5 = dotproduct(Q,k5)
      Qspvak5k2 = dotproduct(Q,spvak5k2)
      Qspvak4k1 = dotproduct(Q,spvak4k1)
      Qspvak5k1 = dotproduct(Q,spvak5k1)
      Qspvae3k1 = dotproduct(Q,spvae3k1)
      Qspvak5e3 = dotproduct(Q,spvak5e3)
      Qspvak2k1 = dotproduct(Q,spvak2k1)
      Qspk1 = dotproduct(Q,k1)
      QspQ = dotproduct(Q,Q)
      Qspe3 = dotproduct(Q,e3)
      Qspe4 = dotproduct(Q,e4)
      Qspvak5k4 = dotproduct(Q,spvak5k4)
      Qspvae4k1 = dotproduct(Q,spvae4k1)
      Qspk4 = dotproduct(Q,k4)
      Qspe2 = dotproduct(Q,e2)
      Qspvae2k1 = dotproduct(Q,spvae2k1)
      acc154(1)=abb154(1)
      acc154(2)=abb154(2)
      acc154(3)=abb154(3)
      acc154(4)=abb154(4)
      acc154(5)=abb154(5)
      acc154(6)=abb154(6)
      acc154(7)=abb154(7)
      acc154(8)=abb154(8)
      acc154(9)=abb154(9)
      acc154(10)=abb154(10)
      acc154(11)=abb154(11)
      acc154(12)=abb154(12)
      acc154(13)=abb154(13)
      acc154(14)=abb154(14)
      acc154(15)=abb154(15)
      acc154(16)=abb154(16)
      acc154(17)=abb154(17)
      acc154(18)=abb154(18)
      acc154(19)=abb154(19)
      acc154(20)=abb154(20)
      acc154(21)=abb154(21)
      acc154(22)=abb154(22)
      acc154(23)=abb154(23)
      acc154(24)=abb154(24)
      acc154(25)=abb154(25)
      acc154(26)=abb154(26)
      acc154(27)=abb154(27)
      acc154(28)=abb154(28)
      acc154(29)=abb154(29)
      acc154(30)=abb154(30)
      acc154(31)=abb154(31)
      acc154(32)=abb154(32)
      acc154(33)=abb154(33)
      acc154(34)=abb154(34)
      acc154(35)=abb154(36)
      acc154(36)=abb154(37)
      acc154(37)=abb154(38)
      acc154(38)=abb154(39)
      acc154(39)=abb154(40)
      acc154(40)=abb154(42)
      acc154(41)=abb154(43)
      acc154(42)=abb154(44)
      acc154(43)=abb154(45)
      acc154(44)=abb154(46)
      acc154(45)=abb154(47)
      acc154(46)=abb154(48)
      acc154(47)=abb154(49)
      acc154(48)=abb154(50)
      acc154(49)=abb154(51)
      acc154(50)=abb154(52)
      acc154(51)=abb154(53)
      acc154(52)=abb154(54)
      acc154(53)=abb154(55)
      acc154(54)=abb154(56)
      acc154(55)=abb154(58)
      acc154(56)=abb154(59)
      acc154(57)=abb154(60)
      acc154(58)=abb154(61)
      acc154(59)=abb154(62)
      acc154(60)=abb154(63)
      acc154(61)=abb154(64)
      acc154(62)=abb154(65)
      acc154(63)=abb154(67)
      acc154(64)=abb154(69)
      acc154(65)=abb154(70)
      acc154(66)=abb154(71)
      acc154(67)=abb154(72)
      acc154(68)=abb154(73)
      acc154(69)=abb154(74)
      acc154(70)=abb154(75)
      acc154(71)=abb154(76)
      acc154(72)=abb154(77)
      acc154(73)=abb154(78)
      acc154(74)=abb154(79)
      acc154(75)=abb154(80)
      acc154(76)=abb154(81)
      acc154(77)=abb154(82)
      acc154(78)=Qspk2+Qspk5
      acc154(79)=acc154(39)*acc154(78)
      acc154(80)=Qspvak5k2*acc154(55)
      acc154(81)=Qspvak4k1*acc154(62)
      acc154(82)=Qspvak5k1*acc154(77)
      acc154(83)=Qspvae3k1*acc154(43)
      acc154(84)=Qspvak5e3*acc154(14)
      acc154(85)=Qspvak2k1*acc154(23)
      acc154(86)=Qspk1*acc154(64)
      acc154(87)=QspQ*acc154(12)
      acc154(88)=-Qspvak5k1*acc154(36)
      acc154(88)=acc154(38)+acc154(88)
      acc154(88)=Qspe3*acc154(88)
      acc154(79)=acc154(88)+acc154(87)+acc154(86)+acc154(85)+acc154(84)+acc154(&
      &83)+acc154(82)+acc154(81)+acc154(31)+acc154(80)+acc154(79)
      acc154(79)=Qspe4*acc154(79)
      acc154(80)=acc154(45)*Qspvak5k4
      acc154(81)=Qspvak4k1*acc154(22)
      acc154(82)=Qspvak5k1*acc154(35)
      acc154(83)=Qspvae4k1*acc154(58)
      acc154(84)=Qspk1*acc154(65)
      acc154(85)=QspQ*acc154(72)
      acc154(80)=acc154(85)+acc154(84)+acc154(83)+acc154(82)+acc154(81)+acc154(&
      &80)+acc154(34)
      acc154(80)=Qspe3*acc154(80)
      acc154(81)=Qspvae3k1*acc154(76)
      acc154(82)=Qspvak5e3*acc154(73)
      acc154(83)=Qspvae4k1*acc154(63)
      acc154(81)=-acc154(83)+acc154(81)+acc154(82)
      acc154(82)=acc154(46)-acc154(81)
      acc154(82)=Qspk4*acc154(82)
      acc154(81)=acc154(44)+acc154(81)
      acc154(81)=Qspk1*acc154(81)
      acc154(83)=Qspvae3k1*acc154(71)
      acc154(84)=Qspvak5e3*acc154(66)
      acc154(85)=Qspvae4k1*acc154(53)
      acc154(83)=acc154(85)+acc154(84)+acc154(27)+acc154(83)
      acc154(83)=QspQ*acc154(83)
      acc154(78)=acc154(3)*acc154(78)
      acc154(84)=Qspvak5k2*acc154(26)
      acc154(85)=Qspvak4k1*acc154(13)
      acc154(86)=Qspvae4k1*acc154(28)
      acc154(78)=acc154(79)+acc154(80)+acc154(83)+acc154(81)+acc154(82)+acc154(&
      &86)+acc154(85)+acc154(29)+acc154(84)+acc154(78)
      acc154(78)=Qspe2*acc154(78)
      acc154(79)=-Qspk1+Qspk2
      acc154(79)=acc154(68)*acc154(79)
      acc154(80)=Qspk5*acc154(59)
      acc154(81)=Qspvak2k1*acc154(9)
      acc154(82)=Qspvae4k1*acc154(8)
      acc154(83)=Qspk4*acc154(40)
      acc154(84)=Qspvae2k1*acc154(7)
      acc154(85)=QspQ*acc154(50)
      acc154(79)=acc154(85)+acc154(84)+acc154(83)+acc154(82)+acc154(81)+acc154(&
      &52)+acc154(80)+acc154(79)
      acc154(79)=QspQ*acc154(79)
      acc154(80)=Qspk1-Qspk4
      acc154(80)=acc154(41)*acc154(80)
      acc154(81)=Qspvak2k1*acc154(15)
      acc154(82)=Qspk5*acc154(67)
      acc154(83)=Qspvae4k1*acc154(74)
      acc154(84)=Qspk2*acc154(69)
      acc154(85)=-Qspvae2k1*acc154(54)
      acc154(80)=acc154(85)+acc154(84)+acc154(83)+acc154(81)+acc154(60)+acc154(&
      &82)+acc154(80)
      acc154(80)=Qspk1*acc154(80)
      acc154(82)=Qspvak2k1*acc154(18)
      acc154(83)=Qspk2*acc154(49)
      acc154(84)=Qspvae2k1*acc154(33)
      acc154(85)=-Qspk1*acc154(24)
      acc154(86)=QspQ*acc154(70)
      acc154(82)=acc154(86)+acc154(85)+acc154(84)+acc154(83)+acc154(25)+acc154(&
      &82)
      acc154(82)=Qspe3*acc154(82)
      acc154(83)=Qspvak2k1*acc154(5)
      acc154(84)=Qspk2*acc154(47)
      acc154(85)=Qspk2-Qspk5
      acc154(86)=-acc154(37)*acc154(85)
      acc154(86)=acc154(30)+acc154(86)
      acc154(86)=Qspvae2k1*acc154(86)
      acc154(87)=Qspk1*acc154(16)
      acc154(88)=Qspvae2k1*acc154(19)
      acc154(88)=acc154(11)+acc154(88)
      acc154(88)=QspQ*acc154(88)
      acc154(82)=acc154(82)+acc154(88)+acc154(87)+acc154(86)+acc154(84)+acc154(&
      &17)+acc154(83)
      acc154(82)=Qspe4*acc154(82)
      acc154(83)=Qspvak2k1*acc154(6)
      acc154(84)=Qspk2*acc154(48)
      acc154(86)=Qspvae2k1*acc154(32)
      acc154(87)=Qspvae4k1*acc154(75)
      acc154(87)=acc154(61)+acc154(87)
      acc154(87)=Qspk1*acc154(87)
      acc154(88)=Qspvae4k1*acc154(56)
      acc154(88)=acc154(20)+acc154(88)
      acc154(88)=QspQ*acc154(88)
      acc154(83)=acc154(88)+acc154(87)+acc154(86)+acc154(84)+acc154(21)+acc154(&
      &83)
      acc154(83)=Qspe3*acc154(83)
      acc154(84)=acc154(1)*acc154(85)
      acc154(85)=Qspk4*acc154(54)
      acc154(84)=acc154(85)+acc154(57)+acc154(84)
      acc154(84)=Qspvae2k1*acc154(84)
      acc154(85)=Qspvak2k1*acc154(2)
      acc154(81)=acc154(42)-acc154(81)
      acc154(81)=Qspk4*acc154(81)
      acc154(86)=Qspk4*acc154(51)
      acc154(86)=acc154(4)+acc154(86)
      acc154(86)=Qspk2*acc154(86)
      brack=acc154(10)+acc154(78)+acc154(79)+acc154(80)+acc154(81)+acc154(82)+a&
      &cc154(83)+acc154(84)+acc154(85)+acc154(86)
   end  function brack_1
!---#] function brack_1:
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use ugaau_groups, only: &
!           & sign => diagram154_sign, shift => diagram154_shift
      use ugaau_globalsl1, only: epspow
      use ugaau_kinematics
      use ugaau_abbrevd154h0
      implicit none
      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d154
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(0:3) :: qshift
      qshift = k2
      Q(1)  =cmplx(real(+Q_ext(4)  -qshift(0),  ki_sam),aimag(+Q_ext(4)),  ki)
      Q(2:4)=cmplx(real(+Q_ext(1:3)-qshift(1:3),ki_sam),aimag(+Q_ext(1:3)),ki)
      mu2    = cmplx(real(mu2_ext, ki), aimag(mu2_ext), ki)
      d154 = 0.0_ki
      d154 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d154, ki), aimag(d154), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use ugaau_globalsl1, only: epspow
      use ugaau_kinematics
      use ugaau_abbrevd154h0
      implicit none
      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d154
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(4) :: qshift
      qshift = k2
      Q(:)  =cmplx(real(+Q_ext(:)  -qshift(:),  ki_gol), 0.0_ki_gol, ki)
      mu2  = cmplx(real(mu2_ext, ki), 0.0_ki, ki)
      d154 = 0.0_ki
      d154 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d154, ki), aimag(d154), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module ugaau_d154h0l1
