module     ugaau_d61h8l1
   ! file: /.th/pcl340/scratch/gosam/greiner/ug_aau/helicity8d61h8l1.f90
   ! generator: buildfortran.py
   use ugaau_config, only: ki
   use ugaau_util, only: cond
   implicit none
   private
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ function brack_1:
   pure function brack_1(Q,mu2) result(brack)
      use ugaau_model
      use ugaau_kinematics
      use ugaau_color
      use ugaau_abbrevd61h8
      implicit none
      complex(ki), dimension(4), intent(in) :: Q
      complex(ki), intent(in) :: mu2
      complex(ki) :: brack
      complex(ki) :: acc61(39)
      complex(ki) :: Qspvak1k3
      complex(ki) :: Qspvak1k5
      complex(ki) :: Qspe4
      complex(ki) :: Qspvak4k3
      complex(ki) :: Qspvak4k5
      complex(ki) :: Qspvak1k4
      complex(ki) :: Qspk4
      complex(ki) :: Qspvak1e4
      complex(ki) :: QspQ
      complex(ki) :: Qspk1
      complex(ki) :: Qspe2
      complex(ki) :: Qspk2
      complex(ki) :: Qspvak1k2
      complex(ki) :: Qspvak1e2
      Qspvak1k3 = dotproduct(Q,spvak1k3)
      Qspvak1k5 = dotproduct(Q,spvak1k5)
      Qspe4 = dotproduct(Q,e4)
      Qspvak4k3 = dotproduct(Q,spvak4k3)
      Qspvak4k5 = dotproduct(Q,spvak4k5)
      Qspvak1k4 = dotproduct(Q,spvak1k4)
      Qspk4 = dotproduct(Q,k4)
      Qspvak1e4 = dotproduct(Q,spvak1e4)
      QspQ = dotproduct(Q,Q)
      Qspk1 = dotproduct(Q,k1)
      Qspe2 = dotproduct(Q,e2)
      Qspk2 = dotproduct(Q,k2)
      Qspvak1k2 = dotproduct(Q,spvak1k2)
      Qspvak1e2 = dotproduct(Q,spvak1e2)
      acc61(1)=abb61(2)
      acc61(2)=abb61(3)
      acc61(3)=abb61(4)
      acc61(4)=abb61(5)
      acc61(5)=abb61(6)
      acc61(6)=abb61(7)
      acc61(7)=abb61(8)
      acc61(8)=abb61(9)
      acc61(9)=abb61(10)
      acc61(10)=abb61(11)
      acc61(11)=abb61(12)
      acc61(12)=abb61(14)
      acc61(13)=abb61(15)
      acc61(14)=abb61(16)
      acc61(15)=abb61(17)
      acc61(16)=abb61(18)
      acc61(17)=abb61(19)
      acc61(18)=abb61(20)
      acc61(19)=abb61(21)
      acc61(20)=abb61(22)
      acc61(21)=abb61(23)
      acc61(22)=abb61(24)
      acc61(23)=abb61(25)
      acc61(24)=abb61(26)
      acc61(25)=abb61(27)
      acc61(26)=abb61(29)
      acc61(27)=abb61(31)
      acc61(28)=abb61(35)
      acc61(29)=abb61(36)
      acc61(30)=Qspvak1k3*acc61(4)
      acc61(31)=Qspvak1k5*acc61(3)
      acc61(30)=acc61(31)+acc61(18)+acc61(30)
      acc61(30)=Qspe4*acc61(30)
      acc61(31)=acc61(25)*Qspvak4k3
      acc61(32)=acc61(19)*Qspvak4k5
      acc61(33)=acc61(16)*Qspvak1k4
      acc61(34)=Qspk4*acc61(21)
      acc61(35)=Qspvak1k3*acc61(15)
      acc61(36)=Qspvak1k5*acc61(13)
      acc61(37)=Qspvak1e4*acc61(24)
      acc61(38)=QspQ*acc61(20)
      acc61(39)=Qspk1*acc61(28)
      acc61(30)=acc61(30)+acc61(39)+acc61(38)+acc61(37)+acc61(36)+acc61(35)+acc&
      &61(34)+acc61(12)+acc61(33)+acc61(31)+acc61(32)
      acc61(30)=Qspe2*acc61(30)
      acc61(31)=Qspk2*acc61(23)
      acc61(32)=Qspvak1k2*acc61(5)
      acc61(33)=QspQ*acc61(8)
      acc61(34)=Qspk1*acc61(9)
      acc61(35)=Qspvak1e2*acc61(11)
      acc61(31)=acc61(35)+acc61(34)+acc61(33)+acc61(32)+acc61(10)+acc61(31)
      acc61(31)=Qspe4*acc61(31)
      acc61(32)=Qspk1-Qspk4
      acc61(32)=acc61(17)*acc61(32)
      acc61(33)=QspQ*acc61(14)
      acc61(32)=acc61(33)+acc61(2)+acc61(32)
      acc61(32)=Qspvak1e2*acc61(32)
      acc61(33)=Qspk2*acc61(22)
      acc61(34)=Qspvak1k2*acc61(1)
      acc61(35)=Qspvak1e4*acc61(29)
      acc61(35)=acc61(6)+acc61(35)
      acc61(35)=QspQ*acc61(35)
      acc61(36)=Qspvak1e4*acc61(26)
      acc61(36)=acc61(27)+acc61(36)
      acc61(36)=Qspk1*acc61(36)
      brack=acc61(7)+acc61(30)+acc61(31)+acc61(32)+acc61(33)+acc61(34)+acc61(35&
      &)+acc61(36)
   end  function brack_1
!---#] function brack_1:
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use ugaau_groups, only: &
!           & sign => diagram61_sign, shift => diagram61_shift
      use ugaau_globalsl1, only: epspow
      use ugaau_kinematics
      use ugaau_abbrevd61h8
      implicit none
      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d61
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(0:3) :: qshift
      qshift = k2
      Q(1)  =cmplx(real(+Q_ext(4)  -qshift(0),  ki_sam),aimag(+Q_ext(4)),  ki)
      Q(2:4)=cmplx(real(+Q_ext(1:3)-qshift(1:3),ki_sam),aimag(+Q_ext(1:3)),ki)
      mu2    = cmplx(real(mu2_ext, ki), aimag(mu2_ext), ki)
      d61 = 0.0_ki
      d61 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d61, ki), aimag(d61), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use ugaau_globalsl1, only: epspow
      use ugaau_kinematics
      use ugaau_abbrevd61h8
      implicit none
      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d61
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(4) :: qshift
      qshift = k2
      Q(:)  =cmplx(real(+Q_ext(:)  -qshift(:),  ki_gol), 0.0_ki_gol, ki)
      mu2  = cmplx(real(mu2_ext, ki), 0.0_ki, ki)
      d61 = 0.0_ki
      d61 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d61, ki), aimag(d61), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module ugaau_d61h8l1
